/*
 * Amiga MUD
 *
 * Copyright (c) 1999 by Chris Gray
 */

/* %%%%%%%%%%%%% grab a copy of the icon editor (in Room/icons.m), and
modify it to be a tile editor. Allow tiles in these drawn rooms. Could
use such an editor in the tile based stuff, too. So, likely want the
actual tile editor off in Common. Also want to use this code to allow
drawing objects. */

/*
 * Common/draw.m - online builder for custom room/object graphics.
 */

public t_draw CreateTable()$
use t_draw

private tp_draw CreateTable()$
use tp_draw

define tp_draw SELECT_SIZE		3$
define tp_draw STANDARD_SIZE		6$

define tp_draw p_pHandlerSave CreateActionProp()$
define tp_draw p_pMouseHandlerSave CreateActionProp()$
define tp_draw p_pButtonRedraw CreateActionProp()$
define tp_draw p_pSaveComponent CreateIntProp()$
define tp_draw p_pDrawing CreateBoolProp()$
define tp_draw p_pDrawingObject CreateBoolProp()$
define tp_draw p_pCurrentObject CreateThingProp()$
define tp_draw p_pDPrevHandler CreateActionProp()$
define tp_draw p_pDColour CreateIntProp()$
define tp_draw p_pDCurrent CreateIntProp()$
define tp_draw p_pDPoint CreateIntProp()$
define tp_draw p_pDSelectX CreateIntProp()$
define tp_draw p_pDSelectY CreateIntProp()$
define tp_draw p_pDKind CreateIntProp()$
define tp_draw p_pDMode CreateIntProp()$
    define tp_draw MODE_MOVE_POINT	0$
    define tp_draw MODE_SEL_ELEM	1$
    define tp_draw MODE_ADD_ELEM	2$
    define tp_draw MODE_PICK_POINT	3$
    define tp_draw MODE_ADD_POINT	4$
    define tp_draw MODE_SEL_COLOUR	5$

define tp_draw p_DrawData CreateThingListProp()$
define tp_draw p_rEffectId CreateIntProp()$
define tp_draw p_dColour CreateIntProp()$
define tp_draw p_dKind CreateIntProp()$
    define tp_draw RBK_LINE			1$
	define tp_draw p_dX1 CreateIntProp()$
	define tp_draw p_dY1 CreateIntProp()$
	define tp_draw p_dX2 CreateIntProp()$
	define tp_draw p_dY2 CreateIntProp()$
    define tp_draw RBK_RECT_LINE		2$
    define tp_draw RBK_RECT_FILL		3$
    define tp_draw RBK_POLY_LINE		4$
	define tp_draw p_dXVec CreateIntListProp()$
	define tp_draw p_dYVec CreateIntListProp()$
    define tp_draw RBK_POLY_FILL		5$
    define tp_draw RBK_ELLIPSE_LINE		6$
	define tp_draw p_dRadius1 CreateIntProp()$
	define tp_draw p_dRadius2 CreateIntProp()$
    define tp_draw RBK_ELLIPSE_FILL		7$
    define tp_draw RBK_DOOR_HOR			8$
    define tp_draw RBK_DOOR_VERT		9$
    define tp_draw RBK_DOOR_N_W			10$
    define tp_draw RBK_DOOR_N_E			11$

define tp_draw EXIT_BUTTON		17$

define tp_draw COMPILE_BUTTON		100$
define tp_draw COLOUR_BUTTON		101$
define tp_draw PREV_BUTTON		102$
define tp_draw NEXT_BUTTON		103$
define tp_draw DELETE_BUTTON		104$
define tp_draw APPEND_BUTTON		105$
define tp_draw BACK_BUTTON		106$
define tp_draw FORWARD_BUTTON		107$
define tp_draw AUTO_BUTTON		108$

define tp_draw ADD_POINT_BUTTON		109$
define tp_draw SUB_POINT_BUTTON		110$

define tp_draw LINE_BUTTON		111$
define tp_draw RECT_L_BUTTON		112$
define tp_draw RECT_F_BUTTON		113$
define tp_draw POLY_L_BUTTON		114$
define tp_draw POLY_F_BUTTON		115$
define tp_draw ELLIPSE_L_BUTTON		116$
define tp_draw ELLIPSE_F_BUTTON		117$
define tp_draw DOOR_HOR_BUTTON		118$
define tp_draw DOOR_VERT_BUTTON		119$
define tp_draw DOOR_N_W_BUTTON		120$
define tp_draw DOOR_N_E_BUTTON		121$

define tp_draw DRAW_REGION		2$

define tp_draw RB_ADD_TOP_BUTTONS_ID NextEffectId()$
define tp_draw proc dAddTopButtons()void:
    int saveComponent;

    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
    if not KnowsEffect(nil, RB_ADD_TOP_BUTTONS_ID) then
	DefineEffect(nil, RB_ADD_TOP_BUTTONS_ID);
	AddButtonRow(0, "EXIT", EXIT_BUTTON, "Compile", COMPILE_BUTTON,
			"Colour", COLOUR_BUTTON, "", 0);
	AddButtonRow(1, "<<==", PREV_BUTTON, "==>>", NEXT_BUTTON,
			"Del El", DELETE_BUTTON, "Add El", APPEND_BUTTON);
	if Me()@p_pDrawingObject then
	    AddButtonRow(2, "<-", BACK_BUTTON, "->", FORWARD_BUTTON,
			    "", 0, "", 0);
	else
	    AddButtonRow(2, "<-", BACK_BUTTON, "->", FORWARD_BUTTON,
			    "Auto", AUTO_BUTTON, "", 0);
	fi;
	EndEffect();
    fi;
    CallEffect(nil, RB_ADD_TOP_BUTTONS_ID);
    ignore DrawComponent(nil, saveComponent);
corp;

define tp_draw proc dAddPointButtons()void:
    int saveComponent;

    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
    AddButtonRow(3, "Add Point", ADD_POINT_BUTTON,
		    "Sub Point", SUB_POINT_BUTTON, "", 0, "", 0);
    ignore DrawComponent(nil, saveComponent);
corp;

define tp_draw RB_ADD_KIND_BUTTONS NextEffectId()$
define tp_draw proc dAddKindButtons()void:
    int saveComponent;

    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
    if not KnowsEffect(nil, RB_ADD_KIND_BUTTONS) then
	DefineEffect(nil, RB_ADD_KIND_BUTTONS);
	AddButtonRow(0, "EXIT", EXIT_BUTTON, "Line", LINE_BUTTON,
			"R Ln", RECT_L_BUTTON, "R Fl", RECT_F_BUTTON);
	AddButtonRow(1, "Poly Line", POLY_L_BUTTON, "Poly Fill", POLY_F_BUTTON,
			"", 0, "", 0);
	AddButtonRow(2, "Elpse Line", ELLIPSE_L_BUTTON,
			"Elpse Fill", ELLIPSE_F_BUTTON,
			"", 0, "", 0);
	AddButtonRow(3, "D -", DOOR_HOR_BUTTON, "D |", DOOR_VERT_BUTTON,
			"D /", DOOR_N_W_BUTTON, "D \\", DOOR_N_E_BUTTON);
	EndEffect();
    fi;
    CallEffect(nil, RB_ADD_KIND_BUTTONS);
    ignore DrawComponent(nil, saveComponent);
corp;

/*
 * doClearButtons - local utility.
 */

define tp_draw proc utility doClearButtons()void:
    int saveComponent;

    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
    ClearButtons();
    ignore DrawComponent(nil, saveComponent);
corp;

define tp_draw proc dSelectBox(int x, y)void:
    thing me, target;

    me := Me();
    GSetPen(nil, C_RED);
    GAMovePixels(nil, x - SELECT_SIZE, y - SELECT_SIZE);
    GRectanglePixels(nil, SELECT_SIZE * 2, SELECT_SIZE * 2, false);
    if me@p_pDrawingObject then
	target := me@p_pCurrentObject;
    else
	target := Here();
    fi;
    GSetPen(nil, target@p_DrawData[me@p_pDCurrent]@p_dColour);
    /* The simply way to do this is to just call DrawLocationName directly,
       right here. However, that results in a change of the drawing
       component, which causes flicker (and misdisplay of the select
       box!!!) in the Java client. So, do it the hard way. */
    me@p_pDSelectX := x;
    me@p_pDSelectY := y;
corp;

define tp_draw proc dDisplayLine(thing th; bool selected)void:

    GAMovePixels(nil, th@p_dX1, th@p_dY1);
    GADrawPixels(nil, th@p_dX2, th@p_dY2);
    if selected then
	if Me()@p_pDPoint = 0 then
	    dSelectBox(th@p_dX1, th@p_dY1);
	else
	    dSelectBox(th@p_dX2, th@p_dY2);
	fi;
    fi;
corp;

define tp_draw proc dDisplayRectLine(thing th; bool selected)void:

    GAMovePixels(nil, th@p_dX1, th@p_dY1);
    GRectanglePixels(nil, th@p_dX2, th@p_dY2, false);
    if selected then
	if Me()@p_pDPoint = 0 then
	    dSelectBox(th@p_dX1, th@p_dY1);
	else
	    dSelectBox(th@p_dX1 + th@p_dX2, th@p_dY1 + th@p_dY2);
	fi;
    fi;
corp;

define tp_draw proc dDisplayRectFill(thing th; bool selected)void:

    GAMovePixels(nil, th@p_dX1, th@p_dY1);
    GRectanglePixels(nil, th@p_dX2, th@p_dY2, true);
    if selected then
	if Me()@p_pDPoint = 0 then
	    dSelectBox(th@p_dX1, th@p_dY1);
	else
	    dSelectBox(th@p_dX1 + th@p_dX2, th@p_dY1 + th@p_dY2);
	fi;
    fi;
corp;

define tp_draw proc dDisplayPolyLine(thing th; bool selected)void:
    list int xVec, yVec;
    int count, i;

    xVec := th@p_dXVec;
    yVec := th@p_dYVec;
    count := Count(xVec);
    GAMovePixels(nil, xVec[0], yVec[0]);
    for i from 1 upto count - 1 do
	GADrawPixels(nil, xVec[i], yVec[i]);
    od;
    GADrawPixels(nil, xVec[0], yVec[0]);
    if selected then
	dSelectBox(xVec[Me()@p_pDPoint], yVec[Me()@p_pDPoint]);
    fi;
corp;

define tp_draw proc dDisplayPolyFill(thing th; bool selected)void:
    list int xVec, yVec;
    int count, i;

    xVec := th@p_dXVec;
    yVec := th@p_dYVec;
    count := Count(xVec);
    GPolygonStart(nil);
    GAMovePixels(nil, xVec[0], yVec[0]);
    for i from 1 upto count - 1 do
	GADrawPixels(nil, xVec[i], yVec[i]);
    od;
    GPolygonEnd(nil);
    if selected then
	dSelectBox(xVec[Me()@p_pDPoint], yVec[Me()@p_pDPoint]);
    fi;
corp;

define tp_draw proc dDisplayEllipseLine(thing th; bool selected)void:

    GAMovePixels(nil, th@p_dX1, th@p_dY1);
    if th@p_dRadius2 = th@p_dRadius1 then
	GCirclePixels(nil, th@p_dRadius1, false);
    else
	GEllipsePixels(nil, th@p_dRadius1, th@p_dRadius2, false);
    fi;
    if selected then
	case Me()@p_pDPoint
	incase 0:
	    dSelectBox(th@p_dX1, th@p_dY1);
	incase 1:
	    dSelectBox(th@p_dX1 - th@p_dRadius1, th@p_dY1);
	incase 2:
	    dSelectBox(th@p_dX1, th@p_dY1 - th@p_dRadius2);
	esac;
    fi;
corp;

define tp_draw proc dDisplayEllipseFill(thing th; bool selected)void:

    GAMovePixels(nil, th@p_dX1, th@p_dY1);
    if th@p_dRadius2 = th@p_dRadius1 then
	GCirclePixels(nil, th@p_dRadius1, true);
    else
	GEllipsePixels(nil, th@p_dRadius1, th@p_dRadius2, true);
    fi;
    if selected then
	case Me()@p_pDPoint
	incase 0:
	    dSelectBox(th@p_dX1, th@p_dY1);
	incase 1:
	    dSelectBox(th@p_dX1 - th@p_dRadius1, th@p_dY1);
	incase 2:
	    dSelectBox(th@p_dX1, th@p_dY1 - th@p_dRadius2);
	esac;
    fi;
corp;

define tp_draw proc dDisplayDrawing(list thing lt)void:
    thing me, th;
    int current, count, i, prevColour, thisColour;
    bool noSel, selected;

    me := Me();
    current := me@p_pDCurrent;
    count := Count(lt);
    prevColour := -1;
    noSel := not me@p_pDrawing or
	me@p_pDMode = MODE_SEL_ELEM or me@p_pDMode = MODE_PICK_POINT;
    for i from 0 upto count - 1 do
	th := lt[i];
	selected := not noSel and current = i;
	thisColour := th@p_dColour;
	if thisColour ~= prevColour then
	    GSetPen(nil, thisColour);
	    prevColour := thisColour;
	fi;
	case th@p_dKind
	incase RBK_LINE:
	    dDisplayLine(th, selected);
	incase RBK_RECT_LINE:
	    dDisplayRectLine(th, selected);
	incase RBK_RECT_FILL:
	    dDisplayRectFill(th, selected);
	incase RBK_POLY_LINE:
	    dDisplayPolyLine(th, selected);
	incase RBK_POLY_FILL:
	    dDisplayPolyFill(th, selected);
	incase RBK_ELLIPSE_LINE:
	    dDisplayEllipseLine(th, selected);
	incase RBK_ELLIPSE_FILL:
	    dDisplayEllipseFill(th, selected);
	incase RBK_DOOR_HOR:
	incase RBK_DOOR_VERT:
	incase RBK_DOOR_N_E:
	incase RBK_DOOR_N_W:
	    GAMovePixels(nil, th@p_dX1, th@p_dY1);
	    case th@p_dKind
	    incase RBK_DOOR_HOR:
		HorizontalDoor();
	    incase RBK_DOOR_VERT:
		VerticalDoor();
	    incase RBK_DOOR_N_E:
		NorthEastDoor();
	    incase RBK_DOOR_N_W:
		NorthWestDoor();
	    esac;
	    if selected then
		dSelectBox(th@p_dX1, th@p_dY1);
	    fi;
	default:
	    Print("Unknown draw kind " + IntToString(th@p_dKind) + "\n");
	esac;
    od;
corp;

define tp_draw proc dDisplayRoom()void:
    list thing lt;

    lt := Here()@p_DrawData;
    if lt ~= nil then
	dDisplayDrawing(lt);
	DrawLocationName(IntToString(Me()@p_pDSelectX),
			 IntToString(Me()@p_pDSelectY));
    fi;
corp;

define tp_draw proc dDisplayObject(thing object)void:
    list thing lt;

    GClear(nil);
    lt := object@p_DrawData;
    if lt ~= nil then
	dDisplayDrawing(lt);
    fi;
corp;

define tp_draw proc utility dAdjustHorDoor(thing th; int x, y)void:

    if x < DOOR_HALF_WIDTH then
	x := DOOR_HALF_WIDTH;
    elif x >= DRAW_COLS - DOOR_HALF_WIDTH then
	x := DRAW_COLS - DOOR_HALF_WIDTH - 1;
    fi;
    if y < DOOR_HALF_HEIGHT then
	y := DOOR_HALF_HEIGHT;
    elif y >= DRAW_ROWS - DOOR_HALF_HEIGHT then
	y := DRAW_ROWS - DOOR_HALF_HEIGHT - 1;
    fi;
    th@p_dX1 := x;
    th@p_dY1 := y;
corp;

define tp_draw proc utility dAdjustVertDoor(thing th; int x, y)void:

    if x < DOOR_HALF_HEIGHT then
	x := DOOR_HALF_HEIGHT;
    elif x >= DRAW_COLS - DOOR_HALF_HEIGHT then
	x := DRAW_COLS - DOOR_HALF_HEIGHT - 1;
    fi;
    if y < DOOR_HALF_WIDTH then
	y := DOOR_HALF_WIDTH;
    elif y >= DRAW_ROWS - DOOR_HALF_WIDTH then
	y := DRAW_ROWS - DOOR_HALF_WIDTH - 1;
    fi;
    th@p_dX1 := x;
    th@p_dY1 := y;
corp;

define tp_draw proc utility dAdjustSlantDoor(thing th; int x, y)void:

    if x < DOOR_HALF_HEIGHT + DOOR_HALF_WIDTH then
	x := DOOR_HALF_HEIGHT + DOOR_HALF_WIDTH;
    elif x >= DRAW_COLS - DOOR_HALF_HEIGHT - DOOR_HALF_WIDTH then
	x := DRAW_COLS - DOOR_HALF_HEIGHT - DOOR_HALF_WIDTH - 1;
    fi;
    if y < DOOR_HALF_HEIGHT + DOOR_HALF_WIDTH then
	y := DOOR_HALF_HEIGHT + DOOR_HALF_WIDTH;
    elif y >= DRAW_ROWS - DOOR_HALF_HEIGHT - DOOR_HALF_WIDTH then
	y := DRAW_ROWS - DOOR_HALF_HEIGHT - DOOR_HALF_WIDTH - 1;
    fi;
    th@p_dX1 := x;
    th@p_dY1 := y;
corp;

define tp_draw proc utility dMovePoint(thing target; int x, y)void:
    thing th;
    int rows, cols, point;

    if Me()@p_pDrawingObject then
	cols := MIN_COLS;
	rows := MIN_ROWS;
    else
	cols := DRAW_COLS;
	rows := DRAW_ROWS
    fi;
    th := target@p_DrawData[Me()@p_pDCurrent];
    point := Me()@p_pDPoint;
    case th@p_dKind
    incase RBK_LINE:
	if point = 0 then
	    if x ~= th@p_dX2 or y ~= th@p_dY2 then
		th@p_dX1 := x;
		th@p_dY1 := y;
	    fi;
	else
	    if x ~= th@p_dX1 or y ~= th@p_dY1 then
		th@p_dX2 := x;
		th@p_dY2 := y;
	    fi;
	fi;
    incase RBK_RECT_LINE:
    incase RBK_RECT_FILL:
	if point = 0 then
	    if x + th@p_dX2 >= cols then
		x := cols - th@p_dX2 - 1;
	    fi;
	    th@p_dX1 := x;
	    if y + th@p_dY2 >= rows then
		y := rows - th@p_dY2 - 1;
	    fi;
	    th@p_dY1 := y;
	else
	    if x <= th@p_dX1 then
		x := th@p_dX1 + 1;
	    fi;
	    th@p_dX2 := x - th@p_dX1;
	    if y <= th@p_dY1 then
		y := th@p_dY1 + 1;
	    fi;
	    th@p_dY2 := y - th@p_dY1;
	fi;
    incase RBK_POLY_LINE:
    incase RBK_POLY_FILL:
	th@p_dXVec[point] := x;
	th@p_dYVec[point] := y;
    incase RBK_ELLIPSE_LINE:
    incase RBK_ELLIPSE_FILL:
	case point
	incase 0:
	    if x - th@p_dRadius1 < 0 then
		x := th@p_dRadius1;
	    elif x + th@p_dRadius1 >= cols then
		x := cols - th@p_dRadius1 - 1;
	    fi;
	    th@p_dX1 := x;
	    if y - th@p_dRadius2 < 0 then
		y := th@p_dRadius2;
	    elif y + th@p_dRadius2 >= rows then
		y := rows - th@p_dRadius2 - 1;
	    fi;
	    th@p_dY1 := y;
	incase 1:
	    if x >= th@p_dX1 then
		x := th@p_dX1 - 1;
	    elif th@p_dX1 + th@p_dX1 - x >= cols then
		x := 2 * th@p_dX1 - cols + 1;
	    fi;
	    th@p_dRadius1 := th@p_dX1 - x;
	incase 2:
	    if y >= th@p_dY1 then
		y := th@p_dY1 - 1;
	    elif th@p_dY1 + th@p_dY1 - y >= rows then
		y := 2 * th@p_dY1 - rows + 1;
	    fi;
	    th@p_dRadius2 := th@p_dY1 - y;
	esac;
    incase RBK_DOOR_HOR:
	dAdjustHorDoor(th, x, y);
    incase RBK_DOOR_VERT:
	dAdjustVertDoor(th, x, y);
    incase RBK_DOOR_N_W:
    incase RBK_DOOR_N_E:
	dAdjustSlantDoor(th, x, y);
    esac;
corp;

define tp_draw proc utility dSelectElement(thing target; int x, y)void:

    Print("Selecting an element is not implemented.\n");
corp;

define tp_draw proc utility dAddElement(thing target; int x, y)void:
    list thing oldList, newList;
    list int vec;
    thing me, th;
    int cols, rows, kind, count, current, i;

    me := Me();
    if me@p_pDrawingObject then
	cols := MIN_COLS;
	rows := MIN_ROWS;
    else
	cols := DRAW_COLS;
	rows := DRAW_ROWS
    fi;
    kind := me@p_pDKind;
    if kind = -1 then
	Print("No kind when adding element!\n");
	kind := RBK_LINE;
    fi;
    /* We create standard-sized entities. Make sure they fit. */
    if x < STANDARD_SIZE then
	x := STANDARD_SIZE;
    elif x > cols - STANDARD_SIZE then
	x := cols - STANDARD_SIZE;
    fi;
    if y < STANDARD_SIZE then
	y := STANDARD_SIZE;
    elif y > rows - STANDARD_SIZE then
	y := rows - STANDARD_SIZE;
    fi;
    th := CreateThing(nil);
    SetThingStatus(th, ts_readonly);
    th@p_dColour := me@p_pDColour;
    th@p_dKind := kind;
    case kind
    incase RBK_LINE:
	th@p_dX1 := x - STANDARD_SIZE;
	th@p_dY1 := y - STANDARD_SIZE;
	th@p_dX2 := x + STANDARD_SIZE;
	th@p_dY2 := y + STANDARD_SIZE;
    incase RBK_RECT_LINE:
    incase RBK_RECT_FILL:
	th@p_dX1 := x - STANDARD_SIZE;
	th@p_dY1 := y - STANDARD_SIZE;
	th@p_dX2 := STANDARD_SIZE * 2;
	th@p_dY2 := STANDARD_SIZE * 2;
    incase RBK_POLY_LINE:
    incase RBK_POLY_FILL:
	vec := CreateIntArray(3);
	vec[0] := x;
	vec[1] := x + STANDARD_SIZE;
	vec[2] := x - STANDARD_SIZE;
	th@p_dXVec := vec;
	vec := CreateIntArray(3);
	vec[0] := y - STANDARD_SIZE;
	vec[1] := y + STANDARD_SIZE;
	vec[2] := y + STANDARD_SIZE;
	th@p_dYVec := vec;
    incase RBK_ELLIPSE_LINE:
    incase RBK_ELLIPSE_FILL:
	th@p_dX1 := x;
	th@p_dY1 := y;
	th@p_dRadius1 := STANDARD_SIZE;
	th@p_dRadius2 := STANDARD_SIZE;
    incase RBK_DOOR_HOR:
	dAdjustHorDoor(th, x, y);
    incase RBK_DOOR_VERT:
	dAdjustVertDoor(th, x, y);
    incase RBK_DOOR_N_W:
    incase RBK_DOOR_N_E:
	dAdjustSlantDoor(th, x, y);
    esac;
    oldList := target@p_DrawData;
    if oldList = nil then
	newList := CreateThingList();
	target@p_DrawData := newList;
	AddTail(newList, th);
	me@p_pDCurrent := 0;
    else
	current := me@p_pDCurrent;
	count := Count(oldList);
	if current = count - 1 then
	    AddTail(oldList, th);
	else
	    newList := CreateThingList();
	    for i from 0 upto current do
		AddTail(newList, oldList[i]);
	    od;
	    AddTail(newList, th);
	    for i from current + 1 upto count - 1 do
		AddTail(newList, oldList[i]);
	    od;
	    target@p_DrawData := newList;
	fi;
	me@p_pDCurrent := current + 1;
    fi;
    me@p_pDPoint := 0;
corp;

define tp_draw proc dExitKindSelect(thing target)void:
    list thing lt;
    int kind;

    doClearButtons();
    dAddTopButtons();
    lt := target@p_DrawData;
    if lt ~= nil and Count(lt) ~= 0 then
	kind := lt[Me()@p_pDCurrent]@p_dKind;
	if kind = RBK_POLY_LINE or kind = RBK_POLY_FILL then
	    dAddPointButtons();
	fi;
    fi;
    ignore SetCharacterButtonAction(Me()@p_pDPrevHandler);
corp;

define tp_draw proc dSelectPoint(thing target; int x, y)void:

    Print("Selecting a point is not implemented.\n");
corp;

define tp_draw proc utility dAddPoint(thing target; int x, y)void:
    list int oldXVec, oldYVec, newXVec, newYVec;
    thing me, th;
    int point, points, i;

    me := Me();
    th := target@p_DrawData[me@p_pDCurrent];
    point := me@p_pDPoint;
    oldXVec := th@p_dXVec;
    oldYVec := th@p_dYVec;
    points := Count(oldXVec);
    newXVec := CreateIntArray(points + 1);
    newYVec := CreateIntArray(points + 1);
    for i from 0 upto point do
	newXVec[i] := oldXVec[i];
	newYVec[i] := oldYVec[i];
    od;
    newXVec[point + 1] := x;
    newYVec[point + 1] := y;
    for i from point + 1 upto points - 1 do
	newXVec[i + 1] := oldXVec[i];
	newYVec[i + 1] := oldYVec[i];
    od;
    th@p_dXVec := newXVec;
    th@p_dYVec := newYVec;
    me@p_pDPoint := point + 1;
corp;

define tp_draw proc dSelectColour(int x, y)bool:
    int setWidth, setHeight, boxWidth, boxHeight, r, g, b;

    boxWidth := MIN_COLS / (3 * 7);
    boxHeight := MIN_ROWS / (2 * 6 + 1);
    setWidth := boxWidth * 7;
    setHeight := boxHeight * 6;
    if y >= setHeight * 2 then
	if y < setHeight * 2 + boxHeight and x < boxWidth * 4 then
	    Me()@p_pDColour := 252 + x / boxWidth;
	    true
	else
	    false
	fi
    elif x >= setWidth * 3 then
	false
    else
	r := y / setHeight * 3 + x / setWidth;
	x := x % setWidth;
	y := y % setHeight;
	g := x / boxWidth;
	b := y / boxHeight;
	Me()@p_pDColour := ((r * 7) + g) * 6 + b;
	true
    fi
corp;

define tp_draw proc utility dMouseDownHandler(int region, x, y)void:
    list thing lt;
    thing me, target;
    int mode;
    bool ok;

    me := Me();
    if me@p_pDrawingObject then
	target := me@p_pCurrentObject;
    else
	target := Here();
    fi;
    lt := target@p_DrawData;
    mode := me@p_pDMode;
    if lt = nil and mode ~= MODE_SEL_COLOUR and mode ~= MODE_ADD_ELEM then
	Print("There is no drawing data yet. Use 'Add El' button.\n");
    else
	ok := true;
	case mode
	incase MODE_MOVE_POINT:
	    /* Move the current point. */
	    dMovePoint(target, x, y);
	incase MODE_SEL_ELEM:
	    /* Select the "nearest" element. */
	    dSelectElement(target, x, y);
	incase MODE_ADD_ELEM:
	    /* Add a new element. */
	    dAddElement(target, x, y);
	    dExitKindSelect(target);
	incase MODE_PICK_POINT:
	    /* Select the nearest point on the current element. */
	    dSelectPoint(target, x, y);
	incase MODE_ADD_POINT:
	    /* Add a point to the current polygon. */
	    dAddPoint(target, x, y);
	incase MODE_SEL_COLOUR:
	    /* Pick a colour from the displayed palette. */
	    ok := dSelectColour(x, y);
	esac;
	if ok then
	    me@p_pDMode := MODE_MOVE_POINT;
	    if me@p_pDrawingObject then
		dDisplayObject(target);
	    else
		me@p_MapGroup := NO_MAP_GROUP;
		AutoRoomRedrawOnly();
	    fi;
	fi;
    fi;
corp;

define tp_draw proc utility dKindHandler(int whichButton)void:
    thing me, target;
    int kind;

    me := Me();
    if whichButton = EXIT_BUTTON then
	if me@p_pDrawingObject then
	    target := me@p_pCurrentObject;
	else
	    target := Here();
	fi;
	dExitKindSelect(target);
    else
	case whichButton
	incase LINE_BUTTON:
	    kind := RBK_LINE;
	incase RECT_L_BUTTON:
	    kind := RBK_RECT_LINE;
	incase RECT_F_BUTTON:
	    kind := RBK_RECT_FILL;
	incase POLY_L_BUTTON:
	    kind := RBK_POLY_LINE;
	incase POLY_F_BUTTON:
	    kind := RBK_POLY_FILL;
	incase ELLIPSE_L_BUTTON:
	    kind := RBK_ELLIPSE_LINE;
	incase ELLIPSE_F_BUTTON:
	    kind := RBK_ELLIPSE_FILL;
	incase DOOR_HOR_BUTTON:
	    kind := RBK_DOOR_HOR;
	incase DOOR_VERT_BUTTON:
	    kind := RBK_DOOR_VERT;
	incase DOOR_N_E_BUTTON:
	    kind := RBK_DOOR_N_E;
	incase DOOR_N_W_BUTTON:
	    kind := RBK_DOOR_N_W;
	esac;
	me@p_pDKind := kind;
	me@p_pDMode := MODE_ADD_ELEM;
	Print("Select origin for new element\n");
    fi;
corp;

define tp_draw proc utility dDelPoint(thing target)void:
    thing th;
    list int xVecOld, yVecOld, xVecNew, yVecNew;
    int points, point, i;

    th := target@p_DrawData[Me()@p_pDCurrent];
    if th@p_dKind ~= RBK_POLY_LINE and th@p_dKind ~= RBK_POLY_FILL then
	Print("Current element is not a polygon in dDelPoint!\n");
    else
	xVecOld := th@p_dXVec;
	yVecOld := th@p_dYVec;
	points := Count(xVecOld);
	if points < 4 then
	    Print("Too few points left - cannot delete any\n");
	else
	    point := Me()@p_pDPoint;
	    xVecNew := CreateIntArray(points - 1);
	    yVecNew := CreateIntArray(points - 1);
	    for i from 0 upto point - 1 do
		xVecNew[i] := xVecOld[i];
		yVecNew[i] := yVecOld[i];
	    od;
	    for i from point + 1 upto points - 1 do
		xVecNew[i - 1] := xVecOld[i];
		yVecNew[i - 1] := yVecOld[i];
	    od;
	    th@p_dXVec := xVecNew;
	    th@p_dYVec := yVecNew;
	fi;
    fi;
corp;

define tp_draw proc dPointCount(thing th)int:

    case th@p_dKind
    incase RBK_LINE:
    incase RBK_RECT_LINE:
    incase RBK_RECT_FILL:
	2
    incase RBK_POLY_LINE:
    incase RBK_POLY_FILL:
	Count(th@p_dXVec)
    incase RBK_ELLIPSE_LINE:
    incase RBK_ELLIPSE_FILL:
	3
    incase RBK_DOOR_HOR:
    incase RBK_DOOR_VERT:
    incase RBK_DOOR_N_E:
    incase RBK_DOOR_N_W:
	1
    default:
	1
    esac
corp;

define tp_draw PALETTE_ID NextEffectId()$
define tp_draw proc dShowPalette()void:
    int setWidth, setHeight, boxWidth, boxHeight, i, j, k, l;

    if not KnowsEffect(nil, PALETTE_ID) then
	DefineEffect(nil, PALETTE_ID);
	GClear(nil);
	boxWidth := MIN_COLS / (3 * 7);
	boxHeight := MIN_ROWS / (2 * 6 + 1);
	setWidth := boxWidth * 7;
	setHeight := boxHeight * 6;
	for i from 0 upto 2 do
	    for j from 0 upto 1 do
		for k from 0 upto 6 do
		    for l from 0 upto 5 do
			GAMovePixels(nil, i * setWidth + k * boxWidth,
				     j * setHeight + l * boxHeight);
			GSetPen(nil, ((j * 3 + i) * 7 + k) * 6 + l);
			GRectanglePixels(nil, boxWidth, boxHeight, true);
		    od;
		od;
	    od;
	od;
	for i from 0 upto 3 do
	    GAMovePixels(nil, i * boxWidth, setHeight * 2);
	    GSetPen(nil, 252 + i);
	    GRectanglePixels(nil, boxWidth, boxHeight, true);
	od;
	EndEffect();
    fi;
    CallEffect(nil, PALETTE_ID);
corp;

define tp_draw proc dPair(int x, y)string:

    IntToString(x) + ", " + IntToString(y)
corp;

define tp_draw proc dCompileRectangle(thing th; string fill)string:
    string code;

    code := "  GAMovePixels(nil, " + dPair(th@p_dX1, th@p_dY1) + ");\n";
    code + "  GRectanglePixels(nil, " + dPair(th@p_dX2, th@p_dY2) + ", " +
	fill + ");\n"
corp;

define tp_draw proc dCompilePolygon(thing th; bool fill)string:
    list int xVec, yVec;
    string code;
    int count, i;

    xVec := th@p_dXVec;
    yVec := th@p_dYVec;
    count := Count(xVec);
    if fill then
	code := "  GPolygonStart(nil);\n";
    else
	code := "";
    fi;
    code := code + "  GAMovePixels(nil, " + dPair(xVec[0], yVec[0]) + ");\n";
    for i from 1 upto count - 1 do
	code := code + "  GADrawPixels(nil, " +
	    dPair(xVec[i], yVec[i]) + ");\n";
    od;
    if fill then
	code := code + "  GPolygonEnd(nil);\n";
    else
	code := code + "  GADrawPixels(nil, " + dPair(xVec[0], yVec[0]) +
	    ");\n";
    fi;
    code
corp;

define tp_draw proc dCompileEllipse(thing th; string fill)string:
    string code;

    code := "  GAMovePixels(nil, " +
	dPair(th@p_dX1, th@p_dY1) + ");\n";
    if th@p_dRadius2 = th@p_dRadius1 then
	code + "  GCirclePixels(nil, " + IntToString(th@p_dRadius1) + ", " +
	    fill + ");\n"
    else
	code + "  GEllipsePixels(nil, " +
	    dPair(th@p_dRadius1, th@p_dRadius2) + ", " + fill + ");\n"
    fi
corp;

define tp_draw proc utility dCompileGraphics(thing target)void:
    list thing lt;
    thing th;
    string code;
    action a;
    int id, count, i, prevColour, thisColour;
    bool drawingObject;

    drawingObject := Me()@p_pDrawingObject;
    id := NextEffectId();
    target@p_rEffectId := id;
    if drawingObject then
	code := "proc(thing object)void:\n";
    else
	code := "proc()void:\n";
    fi;
    code := code + " if not KnowsEffect(nil, " + IntToString(id) + ") then\n";
    code := code + "  DefineEffect(nil, " + IntToString(id) + ");\n";
    lt := target@p_DrawData;
    if lt ~= nil then
	count := Count(lt);
	prevColour := -1;
	for i from 0 upto count - 1 do
	    th := lt[i];
	    thisColour := th@p_dColour;
	    if thisColour ~= prevColour then
		code := code + "  GSetPen(nil, " + IntToString(thisColour) +
		    ");\n";
		prevColour := thisColour;
	    fi;
	    case th@p_dKind
	    incase RBK_LINE:
		code := code + "  GAMovePixels(nil, " +
		    dPair(th@p_dX1, th@p_dY1) + ");\n";
		code := code + "  GADrawPixels(nil, " +
		    dPair(th@p_dX2, th@p_dY2) + ");\n";
	    incase RBK_RECT_LINE:
		code := code + dCompileRectangle(th, "false");
	    incase RBK_RECT_FILL:
		code := code + dCompileRectangle(th, "true");
	    incase RBK_POLY_LINE:
		code := code + dCompilePolygon(th, false);
	    incase RBK_POLY_FILL:
		code := code + dCompilePolygon(th, true);
	    incase RBK_ELLIPSE_LINE:
		code := code + dCompileEllipse(th, "false");
	    incase RBK_ELLIPSE_FILL:
		code := code + dCompileEllipse(th, "true");
	    incase RBK_DOOR_HOR:
	    incase RBK_DOOR_VERT:
	    incase RBK_DOOR_N_E:
	    incase RBK_DOOR_N_W:
		code := code + "  GAMovePixels(nil, " +
		    dPair(th@p_dX1, th@p_dY1) + ");\n";
		case th@p_dKind
		incase RBK_DOOR_HOR:
		    code := code + "  HorizontalDoor();\n";
		incase RBK_DOOR_VERT:
		    code := code + "  VerticalDoor();\n";
		incase RBK_DOOR_N_E:
		    code := code + "  NorthEastDoor();\n";
		incase RBK_DOOR_N_W:
		    code := code + "  NorthWestDoor();\n";
		esac;
	    default:
		Print("Unknown draw kind " + IntToString(th@p_dKind) + "\n");
	    esac;
	od;
    fi;
    code := code + "  EndEffect();\n";
    code := code + " fi;\n";
    code := code + " CallEffect(nil, " + IntToString(id) + ");\n";
    code := code + "corp";
    a := StringToProc(code);
    if drawingObject then
	Me()@p_pCurrentObject@p_oDrawAction := a;
    else
	Here()@p_rDrawAction := a;
    fi;
    Print("Room drawing routine is effect " + IntToString(id) + "\n");
corp;

define tp_draw proc drawReset()void: corp;

define tp_draw proc drawActiveAction()void:

    Print("\n* You were doing a drawing when a backup was made. The "
	  "system is now running from that backup. Your drawing changes "
	  "should still be valid. *\n\n");
    drawReset();
corp;

replace drawReset()void:
    thing me;

    me := Me();
    DelElement(me@p_pEnterActions, drawActiveAction);
    DelElement(me@p_pExitActions, drawReset);
    me -- p_pDrawingObject;
    me -- p_pCurrentObject;
    me -- p_pButtonRedraw;
    me -- p_pDrawing;
    me -- p_pSaveComponent;
    me -- p_pDColour;
    me -- p_pDCurrent;
    me -- p_pDMode;
    me -- p_pDPoint;
    me -- p_pDKind;
    ignore SetCharacterButtonAction(me@p_pHandlerSave);
    me -- p_pHandlerSave;
    ignore SetCharacterMouseDownAction(me@p_pMouseHandlerSave);
    me -- p_pMouseHandlerSave;
    EraseRegion(DRAW_REGION);
corp;

define t_draw proc EndDraw()void:
    thing me;
    action a;

    me := Me();
    if me@p_pDrawing then
	doClearButtons();
	me@p_pDCurrent := -1;	/* Want no select box. */
	if me@p_pDrawingObject then
	    dDisplayObject(me@p_pCurrentObject);
	    ignore DrawComponent(nil, me@p_pSaveComponent);
	else
	    AutoRoomRedraw();
	fi;
	a := me@p_pButtonRedraw;
	drawReset();
	if a ~= nil then
	    call(a, void)();
	fi;
    fi;
corp;

define tp_draw proc utility dTopButtonHandler(int whichButton)void:
    list thing lt;
    thing me, target;
    int count, current, point, oldKind, newKind, saveComponent;

    me := Me();
    if me@p_pDrawingObject then
	target := me@p_pCurrentObject;
    else
	target := Here();
    fi;
    lt := target@p_DrawData;
    if (lt = nil or Count(lt) = 0) and
	whichButton ~= APPEND_BUTTON and whichButton ~= COLOUR_BUTTON and
	whichButton ~= EXIT_BUTTON and whichButton ~= AUTO_BUTTON
    then
	Print("There is no drawing data yet. Use 'Add El' button.\n");
    else
	current := me@p_pDCurrent;
	point := me@p_pDPoint;
	case whichButton
	incase EXIT_BUTTON:
	    EndDraw();
	incase COMPILE_BUTTON:
	    dCompileGraphics(target);
	incase COLOUR_BUTTON:
	    dShowPalette();
	    me@p_pDMode := MODE_SEL_COLOUR;
	incase PREV_BUTTON:
	    oldKind := lt[current]@p_dKind;
	    if current = 0 then
		current := Count(lt) - 1;
	    else
		current := current - 1;
	    fi;
	    me@p_pDMode := MODE_MOVE_POINT;
	incase NEXT_BUTTON:
	    oldKind := lt[current]@p_dKind;
	    if current = Count(lt) - 1 then
		current := 0;
	    else
		current := current + 1;
	    fi;
	    me@p_pDMode := MODE_MOVE_POINT;
	incase DELETE_BUTTON:
	    DelElement(lt, lt[current]);
	    count := Count(lt);
	    if current >= count then
		if count = 0 then
		    target -- p_DrawData;
		    GClear(nil);
		else
		    me@p_pDCurrent := count - 1;
		fi;
	    fi;
	    me@p_pDPoint := 0;
	    me@p_pDMode := MODE_MOVE_POINT;
	incase APPEND_BUTTON:
	    doClearButtons();
	    dAddKindButtons();
	    me@p_pDPrevHandler := SetCharacterButtonAction(dKindHandler);
	incase BACK_BUTTON:
	    if point = 0 then
		me@p_pDPoint := dPointCount(lt[current]) - 1;
	    else
		me@p_pDPoint := point - 1;
	    fi;
	    me@p_pDMode := MODE_MOVE_POINT;
	incase FORWARD_BUTTON:
	    if point = dPointCount(lt[current]) - 1 then
		me@p_pDPoint := 0;
	    else
		me@p_pDPoint := point + 1;
	    fi;
	    me@p_pDMode := MODE_MOVE_POINT;
	incase AUTO_BUTTON:
	    if target@p_rDrawBoth then
		target -- p_rDrawBoth;
		Print("AutoGraphics background will not be shown.\n");
	    else
		target@p_rDrawBoth := true;
		Print("AutoGraphics background will be shown.\n");
	    fi;
	incase ADD_POINT_BUTTON:
	    me@p_pDMode := MODE_ADD_POINT;
	incase SUB_POINT_BUTTON:
	    dDelPoint(target);
	    me@p_pDMode := MODE_MOVE_POINT;
	esac;
	if whichButton = PREV_BUTTON or whichButton = NEXT_BUTTON then
	    me@p_pDCurrent := current;
	    me@p_pDPoint := 0;
	    newKind := lt[current]@p_dKind;
	    if oldKind = RBK_POLY_LINE or oldKind = RBK_POLY_FILL then
		if newKind ~= RBK_POLY_LINE and newKind ~= RBK_POLY_FILL then
		    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
		    EraseButton(ADD_POINT_BUTTON);
		    EraseButton(SUB_POINT_BUTTON);
		    ignore DrawComponent(nil, saveComponent);
		fi;
	    else
		if newKind = RBK_POLY_LINE or newKind = RBK_POLY_FILL then
		    saveComponent := DrawComponent(nil, COMPONENT_MBUTTONS);
		    dAddPointButtons();
		    ignore DrawComponent(nil, saveComponent);
		fi;
	    fi;
	fi;
	if whichButton ~= EXIT_BUTTON and whichButton ~= COLOUR_BUTTON then
	    if me@p_pDrawingObject then
		dDisplayObject(target);
	    else
		me@p_MapGroup := NO_MAP_GROUP;
		AutoRoomRedrawOnly();
	    fi;
	fi;
    fi;
corp;

define tp_draw proc utility dStartCommon(thing me)void:

    AddHead(me@p_pEnterActions, drawActiveAction);
    AddHead(me@p_pExitActions, drawReset);
    me@p_pDrawing := true;
    me@p_pDColour := C_WHITE;
    me@p_pDMode := MODE_MOVE_POINT;
    me@p_pDCurrent := 0;
    me@p_pDPoint := 0;
    me@p_pDKind := -1;
    doClearButtons();
corp;

define t_draw proc utility dStartRoom(action buttonRedraw)void:
    thing me;

    me := Me();
    dStartCommon(me);
    RemoveCursor();
    Here()@p_rDrawAction := dDisplayRoom;
    Here()@p_rDrawBoth := true;
    me@p_MapGroup := NO_MAP_GROUP;
    me@p_pButtonRedraw := buttonRedraw;
    AutoRoomRedrawOnly();
    dAddTopButtons();
    me@p_pHandlerSave := SetCharacterButtonAction(dTopButtonHandler);
    AddRegionPixels(0, 0, DRAW_COLS, DRAW_ROWS, DRAW_REGION);
    me@p_pMouseHandlerSave := SetCharacterMouseDownAction(dMouseDownHandler);
corp;

define t_draw proc utility dStartObject(thing object; action buttonRedraw)void:
    thing me;

    me := Me();
    dStartCommon(me);
    me@p_pDrawingObject := true;
    me@p_pCurrentObject := object;
    object@p_oDrawAction := dDisplayObject;
    if me@p_pCurrentMode = Room then
	RemoveCursor();
	me@p_MapGroup := NO_MAP_GROUP;
	me@p_pButtonRedraw := buttonRedraw;
    fi;
    ShowDrawing(dDisplayObject, object);
    dAddTopButtons();
    me@p_pSaveComponent := DrawComponent(nil, getDrawingComponent());
    me@p_pHandlerSave := SetCharacterButtonAction(dTopButtonHandler);
    AddRegionPixels(0, 0, MIN_COLS, MIN_ROWS, DRAW_REGION);
    me@p_pMouseHandlerSave := SetCharacterMouseDownAction(dMouseDownHandler);
corp;

/*
define tp_draw proc public dTest()void:
/*
    list thing lt;
    list int xVec, yVec;
    thing th;

    lt := CreateThingList();
    Here()@p_DrawData := lt;

    th := CreateThing(nil);
    th@p_dColour := C_BLUE;
    th@p_dKind := RBK_LINE;
    th@p_dX1 := 20;
    th@p_dY1 := 10;
    th@p_dX2 := 60;
    th@p_dY2 := 70;
    AddTail(lt, th);

    th := CreateThing(nil);
    th@p_dColour := C_LEMON_YELLOW;
    th@p_dKind := RBK_RECT_LINE;
    th@p_dX1 := 100;
    th@p_dY1 := 10;
    th@p_dX2 := 20;	/* width */
    th@p_dY2 := 30;	/* height */
    AddTail(lt, th);

    th := CreateThing(nil);
    th@p_dColour := C_ORANGE;
    th@p_dKind := RBK_RECT_FILL;
    th@p_dX1 := 100;
    th@p_dY1 := 50;
    th@p_dX2 := 30;	/* width */
    th@p_dY2 := 20;	/* height */
    AddTail(lt, th);

    th := CreateThing(nil);
    th@p_dColour := C_MEDIUM_GREY;
    th@p_dKind := RBK_POLY_LINE;
    xVec := CreateIntArray(5);
    th@p_dXVec := xVec;
    yVec := CreateIntArray(5);
    th@p_dYVec := yVec;
    xVec[0] := 200;
    yVec[0] := 5;
    xVec[1] := 220;
    yVec[1] := 5;
    xVec[2] := 240;
    yVec[2] := 20;
    xVec[3] := 180;
    yVec[3] := 30;
    xVec[4] := 195;
    yVec[4] := 15;
    AddTail(lt,th);

    th := CreateThing(nil);
    th@p_dColour := C_DARK_GREY;
    th@p_dKind := RBK_POLY_FILL;
    xVec := CreateIntArray(6);
    th@p_dXVec := xVec;
    yVec := CreateIntArray(6);
    th@p_dYVec := yVec;
    xVec[0] := 20;
    yVec[0] := 70;
    xVec[1] := 50;
    yVec[1] := 70;
    xVec[2] := 60;
    yVec[2] := 90;
    xVec[3] := 60;
    yVec[3] := 120;
    xVec[4] := 50;
    yVec[4] := 120;
    xVec[5] := 10;
    yVec[5] := 80;
    AddTail(lt,th);

    th := CreateThing(nil);
    th@p_dColour := C_DARK_GREEN;
    th@p_dKind := RBK_ELLIPSE_LINE;
    th@p_dX1 := 100;
    th@p_dY1 := 100;
    th@p_dRadius1 := 30;
    th@p_dRadius2 := 15;
    AddTail(lt,th);

    th := CreateThing(nil);
    th@p_dColour := C_LIGHT_GREEN;
    th@p_dKind := RBK_ELLIPSE_FILL;
    th@p_dX1 := 180;
    th@p_dY1 := 100;
    th@p_dRadius1 := 15;
    th@p_dRadius2 := 30;
    AddTail(lt,th);

    th := CreateThing(nil);
    th@p_dColour := C_TAN;
    th@p_dKind := RBK_ELLIPSE_LINE;
    th@p_dX1 := 220;
    th@p_dY1 := 100;
    th@p_dRadius1 := 20;
    th@p_dRadius2 := 20;
    AddTail(lt,th);
*/

    Me()@p_pDColour := C_WHITE;
    Me()@p_pDMode := MODE_MOVE_POINT;
    Me()@p_pDCurrent := 0;
    Me()@p_pDPoint := 0;
    Me()@p_pDKind := -1;
    AddRegionPixels(0, 0, MIN_COLS, MIN_ROWS, 1);
    DrawLocationNameBox();
    dDisplayRoom();
    dAddTopButtons();
    ignore SetCharacterButtonAction(dTopButtonHandler);
    ignore SetCharacterMouseDownAction(dMouseDownHandler);
corp;
*/

unuse tp_draw
