/*
 * Amiga MUD
 *
 * Copyright (c) 1999 by Chris Gray
 */

/*
 * Room/roomHandlers.m - handlers specific to room locations.
 */

private tp_roomHandlers CreateTable()$
use tp_roomHandlers


define tp_roomHandlers proc RoomIdleAction()void:
    thing me, here;

    me := Me();
    here := Here();
    SetLocation(nil);
    if LightAt(here) then
	ForEachAgent(here, UnShowIconOnce);
    else
	if HasLight(me) then
	    ForEachAgent(here, UnShowRoomFromAgent);
	fi;
    fi;
    SetLocation(here);
    OPrint(Capitalize(me@p_pName) + " has exited the world.\n");
corp;
Room@p_lmIdleAction := RoomIdleAction$


define tp_roomHandlers proc RoomActiveAction1()void:
    thing me;

    me := Me();
    me@p_MapGroup := NO_MAP_GROUP;
    if GOn(nil) then
	InitRoomGraphics();
    else
	me@p_pRoomGraphicsDone := false;
    fi;
    OPrint(Capitalize(me@p_pName) + " has entered the world.\n");
corp;
Room@p_lmActiveAction1 := RoomActiveAction1$


define tp_roomHandlers proc RoomActiveAction2()void:
    thing here;

    here := Here();
    ignore Parse(G, "look around");
    ignore ShowClients(false);
    SetLocation(nil);
    if LightAt(here) then
	SetLocation(here);
	ForEachAgent(here, ShowIconOnce);
    else
	SetLocation(here);
	if HasLight(Me()) then
	    ForEachAgent(here, ShowRoomToAgent);
	fi;
    fi;
corp;
Room@p_lmActiveAction2 := RoomActiveAction2$


define tp_roomHandlers proc RoomGetLocation()thing:
    Here()
corp;
Room@p_lmGetLocation := RoomGetLocation$


define tp_roomHandlers proc RoomGetAgentLocation(thing theAgent)thing:
    AgentLocation(theAgent)
corp;
Room@p_lmGetAgentLocation := RoomGetAgentLocation$


Room@p_lmDoMove := RoomDoMove$


Room@p_lmTryToMove := RoomTryToMove$


Room@p_lmMachineMove := RoomMachineMove$


define tp_roomHandlers proc RoomGetObjectsHere()list thing:

    Here()@p_lContents
corp;
Room@p_lmGetObjectsHere := RoomGetObjectsHere$


define tp_roomHandlers proc RoomIsSceneryHere(string what)bool:
    MatchName(Here()@p_lScenery, what) ~= -1
corp;
Room@p_lmIsSceneryHere := RoomIsSceneryHere$


Room@p_lmCanSeeLocation := CanSee$


define tp_roomHandlers proc RoomCanSeeHere(thing who)bool:
    CanSee(Here(), who)
corp;
Room@p_lmCanSeeHere := RoomCanSeeHere$


Room@p_lmInitialButtonHandler := RoomButtonHandler$


Room@p_lmInitialMouseDownHandler := RoomMouseDownHandler$


define tp_roomHandlers p_lSavedRoom CreateThingProp()$

define tp_roomHandlers proc RoomSaveLocation(thing location, agent)void:
    location@p_lSavedRoom := AgentLocation(agent);
corp;

Room@p_lmSaveLocation := RoomSaveLocation$


define tp_roomHandlers proc RoomSaveHere(thing location)void:
    location@p_lSavedRoom := Here();
corp;

Room@p_lmSaveHere := RoomSaveHere$


define tp_roomHandlers proc RoomForEachLocation(thing location; action a)void:
    ForEachAgent(location@p_lSavedRoom, a);
corp;
Room@p_lmForEachLocation := RoomForEachLocation$


define tp_roomHandlers proc RoomForEachHere(action a)void:
    ForEachAgent(Here(), a);
corp;
Room@p_lmForEachHere := RoomForEachHere$


define tp_roomHandlers proc RoomSayOthersHere(string altName, what)void:
    Say(altName, what);
corp;
Room@p_lmSayOthersHere := RoomSayOthersHere$


define tp_roomHandlers proc RoomPoseOthersHere(string altName, what)void:
    Pose(altName, what);
corp;
Room@p_lmPoseOthersHere := RoomPoseOthersHere$


define tp_roomHandlers proc RoomShowOthersLocation(thing where, who;
	string what)void:
    ABPrint(where, who, who, what);
corp;
Room@p_lmShowOthersLocation := RoomShowOthersLocation$


define tp_roomHandlers proc RoomShowOthersHere(string str)void:
    OPrint(str);
corp;
Room@p_lmShowOthersHere := RoomShowOthersHere$


define tp_roomHandlers proc RoomShowABHere(thing me, who; string what)void:
    ABPrint(Here(), me, who, what);
corp;
Room@p_lmShowABHere := RoomShowABHere$


define tp_roomHandlers proc RoomClearMap()void:
    Me()@p_MapGroup := NO_MAP_GROUP;
corp;
Room@p_lmClearMap := RoomClearMap$


define tp_roomHandlers proc RoomDoAllHere(action a)status:
    DoAll(Here()@p_lContents, a)
corp;
Room@p_lmDoAllHere := RoomDoAllHere$


define tp_roomHandlers proc RoomFindAgentHere(string name)thing:
    FindAgent(name)
corp;
Room@p_lmFindAgentHere := RoomFindAgentHere$


define tp_roomHandlers proc RoomLookDirHere(int dir)string:
    Here()@(DirDesc(dir))
corp;
Room@p_lmLookDirHere := RoomLookDirHere$


define tp_roomHandlers proc RoomDirImageHere(int dir)string:
    Here()@(DirPictureProp(dir))
corp;
Room@p_lmDirImageHere := RoomDirImageHere$


define tp_roomHandlers proc RoomGetForSaleHere()list thing:
    Here()@p_lBuyList
corp;
Room@p_lmGetForSaleHere := RoomGetForSaleHere$


define tp_roomHandlers proc RoomShowHereToMe(bool flag)bool:
    ShowRoomToMe(flag)
corp;
Room@p_lmShowHereToMe := RoomShowHereToMe$


define tp_roomHandlers proc RoomShowExits()void:
    ShowExits(Here());
corp;
Room@p_lmShowExitsHere := RoomShowExits$


define tp_roomHandlers proc RoomShowMe()void:
    if not Me()@p_pHidden and not Here()@p_lDark then
	ForEachAgent(Here(), ShowIconOnce);
    fi;
corp;
Room@p_lmShowMe := RoomShowMe$


define tp_roomHandlers proc RoomUnShowMe()void:
    ForEachAgent(Here(), UnShowIconOnce);
corp;
Room@p_lmUnShowMe := RoomUnShowMe$


define tp_roomHandlers proc RoomAddObjectLocation(thing room, object)void:
    AddTail(room@p_lContents, object);
corp;
Room@p_lmAddObjectLocation := RoomAddObjectLocation$


define tp_roomHandlers proc RoomDelObjectLocation(thing room, object)void:
    DelElement(room@p_lContents, object);
corp;
Room@p_lmDelObjectLocation := RoomDelObjectLocation$


define tp_roomHandlers proc RoomCanFollow(thing leader, follower)bool:
    AgentLocation(leader) = AgentLocation(follower)
corp;
Room@p_lmCanFollow := RoomCanFollow$


define tp_roomHandlers p_pOldHere CreateThingProp()$

define tp_roomHandlers proc RoomStartFollowing(thing leader, follower)void:
corp;
Room@p_lmStartFollowing := RoomStartFollowing$


define tp_roomHandlers proc RoomStopFollowing(thing agent)void:
    agent -- p_pOldHere;
corp;
Room@p_lmStopFollowing := RoomStopFollowing$


define tp_roomHandlers proc RoomAgentStillFollowing(thing leader,follower)bool:
    AgentLocation(follower) = follower@p_pOldHere
corp;
Room@p_lmAgentStillFollowing := RoomAgentStillFollowing$


define tp_roomHandlers proc RoomFollowingStep(thing follower;int leaderDir)int:
    leaderDir
corp;
Room@p_lmFollowingStep := RoomFollowingStep$


define tp_roomHandlers proc RoomFollowSaveLocation(thing agent)void:
    agent@p_pOldHere := Here();
corp;
Room@p_lmFollowSaveLocation := RoomFollowSaveLocation$


define tp_roomHandlers p_pRoomButtonHandlerSave CreateActionProp()$
define tp_roomHandlers p_pRoomMouseDownHandlerSave CreateActionProp()$

define tp_roomHandlers proc RoomLeaveMode(int dir)void:
    LeaveRoomStuff(nil, dir,
		   if dir = D_HERE then MOVE_POOF else MOVE_NORMAL fi);
    Me()@p_pRoomButtonHandlerSave := SetCharacterButtonAction(nil);
    Me()@p_pRoomMouseDownHandlerSave := SetCharacterMouseDownAction(nil);
    SetLocation(nil);
corp;
Room@p_lmLeaveMode := RoomLeaveMode$

define tp_roomHandlers proc RoomResumeMode()void:
    thing me;
    action a;

    me := Me();
    a := me@p_pRoomButtonHandlerSave;
    if a = nil then
	a := RoomButtonHandler;
    fi;
    ignore SetCharacterButtonAction(a);
    me -- p_pRoomButtonHandlerSave;
    a := me@p_pRoomMouseDownHandlerSave;
    if a = nil then
	a := RoomMouseDownHandler;
    fi;
    ignore SetCharacterMouseDownAction(a);
    me -- p_pRoomMouseDownHandlerSave;
    me@p_pCurrentMode := Room;
    if GOn(nil) then
	/* Not for machines */
	InitRoomGraphics();
	DoList(me@p_pToRoomActions);
    fi;
corp;
Room@p_lmResumeMode := RoomResumeMode$


define tp_roomHandlers proc RoomShowAgentView(string name; thing agent)void:
    thing where;
    action a;

    where := AgentLocation(agent);
    if where = nil then
	Print(name + " is not currently anywhere.\n");
    else
	a := where@p_lNameAction;
	if a = nil then
	    Print(name + " is " + where@p_lName + ".\n");
	else
	    Print(name + ": " + call(a, string)() + ".\n");
	fi;
	a := where@p_rDescAction;
	if a = nil then
	    if where@p_rDesc ~= "" then
		Print(where@p_rDesc + "\n");
	    fi;
	    ShowExits(where);
	    ignore ShowList(where@p_lContents, "Nearby:\n");
	else
	    Print(name + ": " + call(a, string)() + ".\n");
	fi;
    fi;
corp;
Room@p_lmShowAgentView := RoomShowAgentView$


define tp_roomHandlers proc RoomPoofToAgent(string name; thing agent)void:
    thing where;

    where := AgentLocation(agent);
    if where = nil then
	Print(name + " is not currently active or anywhere.\n");
    else
	if Here() ~= nil then
	    LeaveRoomStuff(where, 0, MOVE_POOF);
	fi;
	EnterRoomStuff(where, 0, MOVE_POOF);
    fi;
corp;
Room@p_lmPoofToAgent := RoomPoofToAgent$


SetThingStatus(Room, ts_readonly)$


unuse tp_roomHandlers
