/*
 * Amiga MUD
 *
 * Copyright (c) 1999 by Chris Gray
 */

/*
 * Room/roomProp.m - basic properties related to rooms.
 */

public t_roomProp CreateTable()$
use t_roomProp

define t_roomProp p_rDesc CreateStringProp()$	/* full description of room */
define t_roomProp p_rDescAction CreateActionProp()$	/* call proc instead */
define t_baseProp p_rDrawAction CreateActionProp()$	/* a drawing action */
define t_roomProp p_rExits CreateIntListProp()$	/* list of obvious exits */
define t_roomProp p_rFurtherDesc CreateActionProp()$	/* any extra stuff */
define t_roomProp p_rLastVisit CreateIntProp()$		/* for timing things */
define t_roomProp p_rNoGoString CreateStringProp()$	/* print if no go */
define t_roomProp p_rNoGoAction CreateActionProp()$	/* call if cannot go */

define t_roomProp p_rNorthDesc CreateStringProp()$	/* special desc */
define t_roomProp p_rSouthDesc CreateStringProp()$
define t_roomProp p_rEastDesc CreateStringProp()$
define t_roomProp p_rWestDesc CreateStringProp()$
define t_roomProp p_rNorthEastDesc CreateStringProp()$
define t_roomProp p_rNorthWestDesc CreateStringProp()$
define t_roomProp p_rSouthEastDesc CreateStringProp()$
define t_roomProp p_rSouthWestDesc CreateStringProp()$
define t_roomProp p_rUpDesc CreateStringProp()$
define t_roomProp p_rDownDesc CreateStringProp()$
define t_roomProp p_rEnterDesc CreateStringProp()$
define t_roomProp p_rExitDesc CreateStringProp()$

define t_roomProp p_rNorthMessage CreateStringProp()$ /* to player when go */
define t_roomProp p_rSouthMessage CreateStringProp()$
define t_roomProp p_rEastMessage CreateStringProp()$
define t_roomProp p_rWestMessage CreateStringProp()$
define t_roomProp p_rNorthEastMessage CreateStringProp()$
define t_roomProp p_rNorthWestMessage CreateStringProp()$
define t_roomProp p_rSouthEastMessage CreateStringProp()$
define t_roomProp p_rSouthWestMessage CreateStringProp()$
define t_roomProp p_rUpMessage CreateStringProp()$
define t_roomProp p_rDownMessage CreateStringProp()$
define t_roomProp p_rEnterMessage CreateStringProp()$
define t_roomProp p_rExitMessage CreateStringProp()$

define t_roomProp p_rNorthOMessage CreateStringProp()$ /* to others when go */
define t_roomProp p_rSouthOMessage CreateStringProp()$
define t_roomProp p_rEastOMessage CreateStringProp()$
define t_roomProp p_rWestOMessage CreateStringProp()$
define t_roomProp p_rNorthEastOMessage CreateStringProp()$
define t_roomProp p_rNorthWestOMessage CreateStringProp()$
define t_roomProp p_rSouthEastOMessage CreateStringProp()$
define t_roomProp p_rSouthWestOMessage CreateStringProp()$
define t_roomProp p_rUpOMessage CreateStringProp()$
define t_roomProp p_rDownOMessage CreateStringProp()$
define t_roomProp p_rEnterOMessage CreateStringProp()$
define t_roomProp p_rExitOMessage CreateStringProp()$

define t_roomProp p_rNorthEMessage CreateStringProp()$ /*to others when enter*/
define t_roomProp p_rSouthEMessage CreateStringProp()$
define t_roomProp p_rEastEMessage CreateStringProp()$
define t_roomProp p_rWestEMessage CreateStringProp()$
define t_roomProp p_rNorthEastEMessage CreateStringProp()$
define t_roomProp p_rNorthWestEMessage CreateStringProp()$
define t_roomProp p_rSouthEastEMessage CreateStringProp()$
define t_roomProp p_rSouthWestEMessage CreateStringProp()$
define t_roomProp p_rUpEMessage CreateStringProp()$
define t_roomProp p_rDownEMessage CreateStringProp()$
define t_roomProp p_rEnterEMessage CreateStringProp()$
define t_roomProp p_rExitEMessage CreateStringProp()$

/* The various 'checker' lists are private, since they are accessed only
   via the supplied Add/Del Checker routines. */

define tp_room p_rNorthChecks CreateActionListProp()$
define tp_room p_rSouthChecks CreateActionListProp()$
define tp_room p_rEastChecks CreateActionListProp()$
define tp_room p_rWestChecks CreateActionListProp()$
define tp_room p_rNorthEastChecks CreateActionListProp()$
define tp_room p_rNorthWestChecks CreateActionListProp()$
define tp_room p_rSouthEastChecks CreateActionListProp()$
define tp_room p_rSouthWestChecks CreateActionListProp()$
define tp_room p_rUpChecks CreateActionListProp()$
define tp_room p_rDownChecks CreateActionListProp()$
define tp_room p_rEnterChecks CreateActionListProp()$
define tp_room p_rExitChecks CreateActionListProp()$
define tp_room p_rAnyEnterChecks CreateActionListProp()$
define tp_room p_rAnyEnterActions CreateActionListProp()$
define tp_room p_rAnyLeaveChecks CreateActionListProp()$
define tp_room p_rAnyLeaveActions CreateActionListProp()$

define tp_room p_rGetChecks CreateActionListProp()$	/* passed the object */
define tp_room p_rDropChecks CreateActionListProp()$	/* passed the object */

define tp_room p_rSayChecks CreateActionListProp()$	/* passed stuff said */
define tp_room p_rLookChecks CreateActionListProp()$	/* instead of/with */

define tp_room p_rLightChecks CreateActionListProp()$	/* light introduced */

/* properties dealing with the simple graphics stuff */

define t_roomProp p_rEnterRoomDraw CreateActionProp()$
define t_roomProp p_rLeaveRoomDraw CreateActionProp()$
define t_roomProp p_MapGroup CreateIntProp()$


/* Define this early, since it is needed in roomUtil.m/JumpToRoom */

define t_locations Room CreateThing(nil)$
