/*
 * Amiga MUD
 *
 * Copyright (c) 1999 by Chris Gray
 */

/*
 * Tile/tileHandlers.m - handlers specific to tile locations.
 */

private tp_tileHandlers CreateTable()$
use tp_tileHandlers

define t_locations Tile CreateThing(nil)$


define tp_tileHandlers proc TileIdleAction()void:
    TileDelCharacter();
corp;
Tile@p_lmIdleAction := TileIdleAction$


define tp_tileHandlers proc TileActiveAction1()void:
    TileSetupGui();
corp;
Tile@p_lmActiveAction1 := TileActiveAction1$


define tp_tileHandlers proc TileActiveAction2()void:
corp;
Tile@p_lmActiveAction2 := TileActiveAction2$


define tp_tileHandlers proc TileGetLocation()thing:
    Me()@p_pCurrentRoom
corp;
Tile@p_lmGetLocation := TileGetLocation$


define tp_tileHandlers proc TileGetAgentLocation(thing theAgent)thing:
    theAgent@p_pCurrentRoom
corp;
Tile@p_lmGetAgentLocation := TileGetAgentLocation$


Tile@p_lmDoMove := TileStep$


Tile@p_lmTryToMove := TileTryToMove$


Tile@p_lmMachineMove := TileMachineMove$


define tp_tileHandlers proc TileGetObjectsHere()list thing:
    TileGetContents()
corp;
Tile@p_lmGetObjectsHere := TileGetObjectsHere$


define tp_tileHandlers proc TileIsSceneryHere(string what)bool:
    false
corp;
Tile@p_lmIsSceneryHere := TileIsSceneryHere$


define tp_tileHandlers proc TileCanSeeLocation(thing where, who)bool:
    true
corp;
Tile@p_lmCanSeeLocation := TileCanSeeLocation$


define tp_tileHandlers proc TileCanSeeHere(thing who)bool:
    true
corp;
Tile@p_lmCanSeeHere := TileCanSeeHere$


Tile@p_lmInitialButtonHandler := TileButtonHandler$


Tile@p_lmInitialMouseDownHandler := TileMouseDownHandler$


Tile@p_lmSaveLocation := TileSaveLocation$


define tp_tileHandlers proc TileSaveHere(thing location)void:
    TileSaveLocation(location, Me());
corp;
Tile@p_lmSaveHere := TileSaveHere$


Tile@p_lmForEachLocation := TileDoForEachLocation$


define tp_tileHandlers proc TileForEachHere(action a)void:
    ignore TileDoForEachHere(1, a);
corp;
Tile@p_lmForEachHere := TileForEachHere$


define tp_tileHandlers p_pTileAltName CreateStringProp()$
define tp_tileHandlers p_pTileSayString CreateStringProp()$
define tp_tileHandlers proc tileSayTo(thing who)void:
    SayTo(who, Me()@p_pTileAltName, Me()@p_pTileSayString);
corp;
define tp_tileHandlers proc TileSayOthersHere(string altName, what)void:
    thing me;

    me := Me();
    me@p_pTileAltName := altName;
    me@p_pTileSayString := what;
    ignore TileDoForEachHere(1, tileSayTo);
    me -- p_pTileSayString;
    me -- p_pTileAltName;
corp;
Tile@p_lmSayOthersHere := TileSayOthersHere$


define tp_tileHandlers proc tilePoseTo(thing who)void:
    PoseTo(who, Me()@p_pTileAltName, Me()@p_pTileSayString);
corp;
define tp_tileHandlers proc TilePoseOthersHere(string altName, what)void:
    thing me;

    me := Me();
    me@p_pTileAltName := altName;
    me@p_pTileSayString := what;
    ignore TileDoForEachHere(1, tilePoseTo);
    me -- p_pTileSayString;
    me -- p_pTileAltName;
corp;
Tile@p_lmPoseOthersHere := TilePoseOthersHere$


define tp_tileHandlers proc tileShowTo(thing who)void:
    SPrint(who, Me()@p_pTileSayString);
corp;
define tp_tileHandlers proc TileShowOthersLocation(thing where, who;
	string what)void:
    /* 'where' may be nil if there is no specific "room" involved. */
    Me()@p_pTileSayString := what;
    ignore TileDoForEachHere(1, tileShowTo);
    Me() -- p_pTileSayString;
corp;
Tile@p_lmShowOthersLocation := TileShowOthersLocation$


define tp_tileHandlers proc TileShowOthersHere(string str)void:
    Me()@p_pTileSayString := str;
    ignore TileDoForEachHere(1, tileShowTo);
    Me() -- p_pTileSayString;
corp;
Tile@p_lmShowOthersHere := TileShowOthersHere$


define tp_tileHandlers p_pTileSpecialWho CreateThingProp()$
define tp_tileHandlers proc tileShowToAB(thing who)void:
    thing me;

    me := Me();
    if who ~= me@p_pTileSpecialWho then
	SPrint(who, me@p_pTileSayString);
    fi;
corp;
define tp_tileHandlers proc TileShowABHere(thing me, who; string what)void:
    me@p_pTileSpecialWho := who;
    me@p_pTileSayString := what;
    ignore TileDoForEachHere(1, tileShowToAB);
    me -- p_pTileSayString;
    me -- p_pTileSpecialWho;
corp;
Tile@p_lmShowABHere := TileShowABHere$


define tp_tileHandlers proc TileDoAllHere(action a)status:
    list thing lt;

    lt := TileGetContents();
    if lt = nil then
	fail
    else
	DoAll(lt, a)
    fi
corp;
Tile@p_lmDoAllHere := TileDoAllHere$


define tp_tileHandlers p_pTileFindName CreateStringProp()$
define tp_tileHandlers p_pTileFoundAgent CreateThingProp()$
define tp_tileHandlers proc tileFindAgent(thing who)void:
    thing me;

    me := Me();
    if me@p_pTileFoundAgent = nil and
	MatchName(who@p_pName, me@p_pTileFindName) ~= -1
    then
	me@p_pTileFoundAgent := who;
    fi;
corp;

define tp_tileHandlers proc TileFindAgentHere(string name)thing:
    thing me, theAgent;

    if name == "me" or name == "myself" or name == "yourself" or name == "self"
    then
	name := MeString();
	if name = "" then
	    me := TrueMe();
	    if me = nil then
		me := Me();
	    fi;
	    if me ~= nil then
		name := SelectWord(me@p_pName, 0);
	    fi;
	fi;
    fi;
    me := Me();
    me@p_pTileFindName := name;
    ignore TileDoForEachHere(1, tileFindAgent);
    me -- p_pTileFindName;
    theAgent := me@p_pTileFoundAgent;
    me -- p_pTileFoundAgent;
    theAgent
corp;
Tile@p_lmFindAgentHere := TileFindAgentHere$


define tp_tileHandlers proc TileLookDirHere(int dir)string:
    ""
corp;
Tile@p_lmLookDirHere := TileLookDirHere$


define tp_tileHandlers proc TileDirImageHere(int dir)string:
    Me()@p_pCurrentRoom@(DirPictureProp(dir))
corp;
Tile@p_lmDirImageHere := TileDirImageHere$


define tp_tileHandlers proc TileGetForSaleHere()list thing:
    nil
corp;
Tile@p_lmGetForSaleHere := TileGetForSaleHere$


define tp_tileHandlers proc tileShowAgent(thing who)void:
    if who ~= Me() then
	if who@p_pName ~= "" and not who@p_pHidden then
	    Print(Capitalize(CharacterNameG(who)) + " is " +
		ShowPosition(who) + "\n");
	fi;
    fi;
corp;

define tp_tileHandlers proc TileShowHereToMe(bool flag)bool:
    thing me;

    me := Me();
    ignore TileDoForEachHere(1, tileShowAgent);
    if not TileShowContents(me, me@p_pCurrentField,
	    me@p_pCurrentRow, me@p_pCurrentCol)
    then
	Print("There is nothing here.\n");
    fi;
    true
corp;
Tile@p_lmShowHereToMe := TileShowHereToMe$


define tp_tileHandlers proc TileShowExitsHere()void:
    Print("There are no obvious exits other than what are visible.\n");
corp;
Tile@p_lmShowExitsHere := TileShowExitsHere$


define tp_tileHandlers proc TileShowMe()void:
    if not Me()@p_pHidden then
	TileAddCharacter();
    fi;
corp;
Tile@p_lmShowMe := TileShowMe$


define tp_tileHandlers proc TileUnShowMe()void:
    if not Me()@p_pHidden then
	TileDelCharacter();
    fi;
corp;
Tile@p_lmUnShowMe := TileUnShowMe$


define tp_tileHandlers proc TileAddObjectLocation(thing room, object)void:
    thing me;

    me := Me();
    TileAddObject(me@p_pCurrentField, object,
	me@p_pCurrentRow, me@p_pCurrentCol);
    TileRedrawCharacter();
corp;
Tile@p_lmAddObjectLocation := TileAddObjectLocation$


define tp_tileHandlers proc TileDelObjectLocation(thing room, object)void:
    thing me;

    me := Me();
    TileDelObject(me@p_pCurrentField, object,
	me@p_pCurrentRow, me@p_pCurrentCol);
    TileRedrawCharacter();
corp;
Tile@p_lmDelObjectLocation := TileDelObjectLocation$


define tp_tileHandlers proc TileCanFollow(thing leader, follower)bool:
    follower@p_pCurrentField = leader@p_pCurrentField and
	(follower@p_pCurrentRow = leader@p_pCurrentRow or
	 follower@p_pCurrentCol = leader@p_pCurrentCol)
corp;
Tile@p_lmCanFollow := TileCanFollow$


define tp_tileHandlers p_pPrevField CreateThingProp()$
define tp_tileHandlers p_pPrevRow CreateIntProp()$
define tp_tileHandlers p_pPrevCol CreateIntProp()$
define tp_tileHandlers p_pPrevDir CreateIntProp()$

define tp_tileHandlers proc TileStartFollowing(thing leader, follower)void:
    int myRow, myCol, leaderRow, leaderCol;

    myRow := follower@p_pCurrentRow;
    myCol := follower@p_pCurrentCol;
    leaderRow := leader@p_pCurrentRow;
    leaderCol := leader@p_pCurrentCol;
    follower@p_pPrevDir :=
	if myRow = leaderRow then
	    if myCol < leaderCol then
		D_EAST
	    else
		D_WEST
	    fi
	elif myRow < leaderRow then
	    D_SOUTH
	else
	    D_NORTH
	fi;
corp;
Tile@p_lmStartFollowing := TileStartFollowing$


define tp_tileHandlers proc TileStopFollowing(thing agent)void:

    agent -- p_pPrevField;
    agent -- p_pPrevRow;
    agent -- p_pPrevCol;
    agent -- p_pPrevDir;
corp;
Tile@p_lmStopFollowing := TileStopFollowing$


define tp_tileHandlers proc TileAgentStillFollowing(thing leader,follower)bool:
    int lRow, lCol, fRow, fCol;

    lRow := leader@p_pCurrentRow;
    lCol := leader@p_pCurrentCol;
    fRow := follower@p_pCurrentRow;
    fCol := follower@p_pCurrentCol;
    follower@p_pCurrentField = follower@p_pPrevField and
	fRow = follower@p_pPrevRow and
	fCol = follower@p_pPrevCol and
	follower@p_pCurrentField = leader@p_pCurrentField and
	(fRow = lRow and (fCol = lCol + 2 or fCol = lCol - 2) or
	 fCol = lCol and (fRow = lRow + 2 or fRow = lRow - 2) or
	 (fRow = lRow - 1 or fRow = lRow + 1) and
	 (fCol = lCol + 1 or fCol = lCol - 1))
corp;
Tile@p_lmAgentStillFollowing := TileAgentStillFollowing$


define tp_tileHandlers proc TileFollowingStep(thing follower;int leaderDir)int:
    int prevDir;

    prevDir := follower@p_pPrevDir;
    follower@p_pPrevDir := leaderDir;
    prevDir
corp;
Tile@p_lmFollowingStep := TileFollowingStep$


define tp_tileHandlers proc TileFollowSaveLocation(thing agent)void:
    agent@p_pPrevField := agent@p_pCurrentField;
    agent@p_pPrevRow := agent@p_pCurrentRow;
    agent@p_pPrevCol := agent@p_pCurrentCol;
corp;
Tile@p_lmFollowSaveLocation := TileFollowSaveLocation$


define tp_tileHandlers p_pTileButtonHandlerSave CreateActionProp()$
define tp_tileHandlers p_pTileMouseDownHandlerSave CreateActionProp()$

define tp_tileHandlers proc TileLeaveMode(int dir)void:
    thing me;

    me := Me();
    if dir = D_HERE then
	TileShowOthersHere(Capitalize(CharacterNameG(me)) + " *POOFS* out.\n");
	Print("*POOF*\n");
    fi;
    TileDelCharacter();
    me@p_pTileButtonHandlerSave := SetCharacterButtonAction(nil);
    me@p_pTileMouseDownHandlerSave := SetCharacterMouseDownAction(nil);
    me -- p_pCurrentField;
    me -- p_pCurrentRow;
    me -- p_pCurrentCol;
    me -- p_pCurrentRoom;
corp;
Tile@p_lmLeaveMode := TileLeaveMode$

define tp_tileHandlers proc TileResumeMode()void:
    thing me;
    action a;

    me := Me();
    a := me@p_pTileButtonHandlerSave;
    if a = nil then
	a := TileButtonHandler;
    fi;
    ignore SetCharacterButtonAction(a);
    me -- p_pTileButtonHandlerSave;
    a := me@p_pTileMouseDownHandlerSave;
    if a = nil then
	a := TileMouseDownHandler;
    fi;
    ignore SetCharacterMouseDownAction(a);
    me -- p_pTileMouseDownHandlerSave;
    me@p_pCurrentMode := Tile;
corp;
Tile@p_lmResumeMode := TileResumeMode$


define tp_tileHandlers proc TileShowAgentView(string name; thing agent)void:
    thing room, field;
    action a;
    bool doneSome;

    Print(name + " is in ");
    doneSome := false;
    room := agent@p_pCurrentRoom;
    if room ~= nil then
	a := room@p_lNameAction;
	if a = nil then
	    name := room@p_lName1;
	    if name ~= "" then
		Print(name);
		doneSome := true;
		name := room@p_lName2;
		if name ~= "" then
		    Print(" " + name);
		fi;
	    fi;
	else
	    Print(call(a, string)());
	    doneSome := true;
	fi;
    fi;
    field := agent@p_pCurrentField;
    name := field@p_fName1;
    if name ~= "" then
	if doneSome then
	    Print("/");
	fi;
	Print(name);
	name := field@p_fName2;
	if name ~= "" then
	    Print(" " + name);
	fi;
    fi;
    Print(" row " + IntToString(agent@p_pCurrentRow) +
	  ", col " + IntToString(agent@p_pCurrentCol) + ".\n");
    ignore TileShowContents(Me(), field, agent@p_pCurrentRow,
			    agent@p_pCurrentCol);
corp;
Tile@p_lmShowAgentView := TileShowAgentView$


define tp_tileHandlers proc TilePoofToAgent(string name; thing agent)void:
    thing me;

    me := Me();
    if me@p_pCurrentField ~= nil then
	TileMaybeDelCharacter();
    fi;
    if me@p_pCurrentField = agent@p_pCurrentField then
	TileReEnter(agent@p_pCurrentRoom,
		    agent@p_pCurrentRow, agent@p_pCurrentCol);
    else
	TileEnter(agent@p_pCurrentField, agent@p_pCurrentRoom,
		  agent@p_pCurrentRow, agent@p_pCurrentCol);
    fi;
    TileShowOthersHere(Capitalize(CharacterNameG(me)) + " *POOFS* in.\n");
corp;
Tile@p_lmPoofToAgent := TilePoofToAgent$


SetThingStatus(Tile, ts_readonly)$


unuse tp_tileHandlers
