private tp_tileWorld CreateTable()$
use tp_tileWorld

Print("Defining the initial tiles.\n")$

define tp_tileWorld t_tiles CreateTable()$
use t_tiles

source /home/cg/MUD/Scen/TileWorld/Character.tile
source /home/cg/MUD/Scen/TileWorld/Packrat.tile
source /home/cg/MUD/Scen/TileWorld/Caretaker.tile
source /home/cg/MUD/Scen/TileWorld/Postman.tile

source /home/cg/MUD/Scen/TileWorld/Grass.tile
source /home/cg/MUD/Scen/TileWorld/Tree.tile
source /home/cg/MUD/Scen/TileWorld/River.tile
source /home/cg/MUD/Scen/TileWorld/Mountain.tile
source /home/cg/MUD/Scen/TileWorld/PineTop.tile
source /home/cg/MUD/Scen/TileWorld/PineBottom.tile
source /home/cg/MUD/Scen/TileWorld/OakTL.tile
source /home/cg/MUD/Scen/TileWorld/OakTR.tile
source /home/cg/MUD/Scen/TileWorld/OakBL.tile
source /home/cg/MUD/Scen/TileWorld/OakBR.tile

source /home/cg/MUD/Scen/TileWorld/Town.tile
source /home/cg/MUD/Scen/TileWorld/Road.tile
source /home/cg/MUD/Scen/TileWorld/Bridge.tile
source /home/cg/MUD/Scen/TileWorld/Teleport.tile

source /home/cg/MUD/Scen/TileWorld/Rock.tile
source /home/cg/MUD/Scen/TileWorld/Log.tile
source /home/cg/MUD/Scen/TileWorld/Branches.tile

Print("Creating the actual tile world.\n")$

define tp_tileWorld TILE_RIVER			100$
define tp_tileWorld TILE_GRASS			101$
define tp_tileWorld TILE_TREES			102$
define tp_tileWorld TILE_MOUNTAIN		103$
define tp_tileWorld TILE_PINE_TOP		104$
define tp_tileWorld TILE_PINE_BOTTOM		105$
define tp_tileWorld TILE_OAK_TOP_LEFT		106$
define tp_tileWorld TILE_OAK_TOP_RIGHT		107$
define tp_tileWorld TILE_OAK_BOTTOM_LEFT	108$
define tp_tileWorld TILE_OAK_BOTTOM_RIGHT	109$

define tp_tileWorld TILE_ROAD			200$
define tp_tileWorld TILE_BRIDGE			201$
define tp_tileWorld TILE_TOWN			202$
define tp_tileWorld TILE_TELEPORT		203$

define tp_tileWorld TILE_ROCK			1000$
define tp_tileWorld TILE_LOG			1001$
define tp_tileWorld TILE_BRANCHES		1002$

define tp_tileWorld TILE_PACKRAT		10001$
define tp_tileWorld TILE_CARETAKER		10002$
define tp_tileWorld TILE_POSTMAN		10003$

define tp_tileWorld WorldThing CreateThing(nil)$
SetThingStatus(WorldThing, ts_readonly)$

define tp_tileWorld p_NextTileId CreateIntProp()$
WorldThing@p_NextTileId := TILE_BASE_CHARACTER + 100$

define t_tileGraphics proc NextTileId()int:
    int id;

    id := WorldThing@p_NextTileId;
    WorldThing@p_NextTileId := id + 1;
    id
corp;

define tp_tileWorld p_KnownCharacterTiles CreateThingListProp()$
WorldThing@p_KnownCharacterTiles := CreateThingList()$

define tp_tileWorld p_tlTransColour CreateIntProp()$
define tp_tileWorld p_tlShirtColour CreateIntProp()$
define tp_tileWorld p_tlPantsColour CreateIntProp()$
define tp_tileWorld p_tlTileId CreateIntProp()$

define tp_tileWorld p_pColourSet CreateBoolProp()$
define tp_tileWorld p_pTransColour CreateIntProp()$
define tp_tileWorld p_pShirtColour CreateIntProp()$
define tp_tileWorld p_pPantsColour CreateIntProp()$

define tp_tileWorld proc createCharacterTile()int:
    list thing knownTiles;
    list int oldTile, newTile;
    thing me, knownTile;
    int trans, shirt, pants, count, i, oldBytes, newBytes, colour, id;
    bool found;

    me := Me();
    trans := me@p_pTransColour;
    shirt := me@p_pShirtColour;
    pants := me@p_pPantsColour;
    knownTiles := WorldThing@p_KnownCharacterTiles;
    count := Count(knownTiles);
    i := 0;
    found := false;
    while i < count and not found do
	knownTile := knownTiles[i];
	if knownTile@p_tlTransColour = trans and
	    knownTile@p_tlShirtColour = shirt and
	    knownTile@p_tlPantsColour = pants
	then
	    found := true;
	fi;
    od;
    if found then
	knownTile@p_tlTileId
    else
	if shirt ~= C_BLACK and pants ~= C_BLACK then
	    trans := C_BLACK;
	elif shirt ~= C_RED and pants ~= C_RED then
	    trans := C_RED;
	else
	    trans := C_BLUE;
	fi;
	oldTile := TileGetTile(me@p_pCurrentField, TILE_BASE_CHARACTER);
	newTile := CreateIntArray(TILE_HEIGHT * TILE_WIDTH / 4);
	for i from 0 upto TILE_HEIGHT * TILE_WIDTH - 1 do
	    newBytes := newBytes << 8;
	    if i % 4 = 0 then
		oldBytes := oldTile[i / 4];
		newBytes := 0x0;
	    fi;
	    colour := (oldBytes >> ((3 - i % 4) * 8)) & 0xff;
	    if colour = C_BLACK then
		newBytes := newBytes | trans
	    elif colour = C_RED then
		newBytes := newBytes | shirt;
	    elif colour = C_BLUE then
		newBytes := newBytes | pants;
	    else
		newBytes := newBytes | colour;
	    fi;
	    if i % 4 = 3 then
		newTile[i / 4] := newBytes;
	    fi;
	od;
	id := NextTileId();
	TileAddTile(me@p_pCurrentField, id, trans, 0, newTile);
	id
    fi
corp;

define tp_tileWorld proc v_shirt(string colour)bool:
    thing me;
    int which;

    if colour = "" then
	Print("Use is: shirt <colour-name>\n");
	ShowKnownColours();
	false
    else
	which := ColourMatch(colour);
	if which = -1 then
	    Print("Colour " + FormatName(colour) + " not known.\n");
	    ShowKnownColours();
	    false
	else
	    me := Me();
	    me@p_pShirtColour := which;
	    me@p_pColourSet := true;
	    if me@p_pCurrentMode = Tile then
		me@p_pCharacterTile := createCharacterTile();
		TileRedrawCharacter();
	    fi;
	    true
	fi
    fi
corp;

define tp_tileWorld proc v_pants(string colour)bool:
    thing me;
    int which;

    if colour = "" then
	Print("Use is: pants <colour-name>\n");
	ShowKnownColours();
	false
    else
	which := ColourMatch(colour);
	if which = -1 then
	    Print("Colour " + FormatName(colour) + " not known.\n");
	    ShowKnownColours();
	    false
	else
	    me := Me();
	    me@p_pPantsColour := which;
	    me@p_pColourSet := true;
	    if me@p_pCurrentMode = Tile then
		me@p_pCharacterTile := createCharacterTile();
		TileRedrawCharacter();
	    fi;
	    true
	fi
    fi
corp;

Verb1(G, "shirt", 0, v_shirt)$
Verb1(G, "pants", 0, v_pants)$

define tp_tileWorld MainField TileCreateField(50, 50, "The Great", "Outdoors")$

define tp_tileWorld proc tileMainDecoder(string ch; int row, col)int:
    int id;

    id := Index("rgtmRBTZ123456", ch);
    if id = -1 then
	Print("Unknown tile char '" + ch + "' at (" + IntToString(row) +
	      "," + IntToString(col) + ").\n");
	TILE_GRASS
    else
	case id
	incase 0:
	    NO_GO_BIT | TILE_RIVER
	incase 1:
	    TILE_GRASS
	incase 2:
	    TILE_TREES
	incase 3:
	    NO_GO_BIT | TILE_MOUNTAIN
	incase 4:
	    TILE_ROAD
	incase 5:
	    TILE_BRIDGE
	incase 6:
	    TILE_TOWN
	incase 7:
	    TILE_TELEPORT
	incase 8:
	    TILE_PINE_TOP
	incase 9:
	    TILE_PINE_BOTTOM
	incase 10:
	    TILE_OAK_TOP_LEFT
	incase 11:
	    TILE_OAK_TOP_RIGHT
	incase 12:
	    TILE_OAK_BOTTOM_LEFT
	incase 13:
	    TILE_OAK_BOTTOM_RIGHT
	default:
	    TILE_GRASS
	esac
    fi
corp;

TileSetRectangle(MainField, 0, 0, 50, 50, tileMainDecoder,
    "tttttttttttttttttttttttttttgggmmmmmmmmmmmmmmmmmmmm"
    "gtttttttttttttttttttttttttggggggmmmmmmmmmmTgmmmmmm"
    "gttttttttttgggggttttttttttttggggtmmmmmmmmmZgmmmmmm"
    "gggttttttttttggggttttttttttgggmmmmmmmmmmmmmgmmmmmm"
    "gggggttttttggggggggtttttttttggggmmmmmmmmmmmgmmmmmm"
    "ggggttttttttggggggggggggtttttttgtrrrrrmmmmmgmmmmmm"
    "gggtttttttggggggggggggggggggttttrggmmmmmggggmmmmmm"
    "ggtttttttggggggggggggggggggggttrggggmmmmgmmmmmmmmm"
    "ggggTtttgggggggggggggggggggggtrggggggmmmgmmmmmmmmm"
    "ggggRttgggmmmgggggggggggggggggrgggmmmmmmgmmmmmmmmm"
    "ggggRgtggmmmmgggggggggggggggggrggmmmmmmmgmmmgmmmmm"
    "ggggRgggmmmmmggggggggggggggggrggmmmmmmmmmmmmgmmmmm"
    "ggggRgggmmmmmgggggggggggggrrrgggggmmmmmmmggggmmmmm"
    "ggggRggmmmmmgggggggggggggrgggggggggmmmmgggmmmmmmmm"
    "mmggRgmmmmmmgggggggggggggrggggggggggmmmggg1mmmmmmm"
    "mmggRgmmmmmgggggggggggggggrggggggggggmgggg211mmmmm"
    "mgggRmmmmggggggggggggggggggrggggggggggggggg2211mmm"
    "ggggRgmmmmggggggggggggggggggrgggggggggggggggg221mm"
    "ggggRRRRRgmmgggggggggggggggggrgggrrgggggggggggg21m"
    "ggggggggRgmmmgggggggggggggggggrrrggrrrrrrgggggg121"
    "ggggggggRggmgggggggggttggggggggggggggggggrggggg2g2"
    "ggggggggRggggggggggttttttgggggggggggggggggrggggggg"
    "ggggggggRgggggggggggttttttttttgggggggggggggrgggggg"
    "ggggggggRgggggggggggggggttttttttgggggggggggBgggggg"
    "ggggggggRRRRRRRRRRRRTgggttttttttgggggggggggrgggggg"
    "ggggggggRggggggggggggggttttttttggggggggggggrgggggg"
    "ggggggggRggggggggggggggggttttttgggggggggggrrrggggg"
    "ggggggggRggggggggggggggttttttggggggggggggrgggrgggg"
    "ggggggggRggggggggggggtttttttggggggggrrrrrgggggrggg"
    "ggggggggRgggggggggggtttttggggggggrrrgggggggggggrgg"
    "ggggggggRgggggggtttttttttttgggggrggggggg34ggggggrr"
    "ggggggggRggggggggttttttttttrrrrrgggg343456gggggggg"
    "ggggggggRgggggggggtttttttrrtttgggggg5656g34ggggggg"
    "ggggggggRgggggggggtttrrrrttttgggggg34gggg56ggggggg"
    "ggggggggRggggggggggtrrrrrrrtggggggg56gg34ggggggggt"
    "ggggggggRggggggggggggrrrrrrrggggggggg3456gggggggtt"
    "ggggggggRggggggggggggggrrrrgggggggggg56gggggggggtt"
    "ggttggggRgggg34gggggggggrrrgggggggggggggggtggggggt"
    "ttttttggRgggg56ggggggrrrrrgggggggggggggggttggggttt"
    "tttttttgRgggggggggggrrrrrrrrgggggggggggggggggttttt"
    "ttttttggRggggggggggrrrrrrrrrrgggggggggggggggttttZg"
    "RRRRRRRRRRRRRRRRRRRBRRTrrrrrgggggggggggggggttttggt"
    "tttttgggRggggggggggrrgTTrrrrrggggggggggggtttttggtt"
    "tttttgggRgggggggggggrrggggrrrrggggggggtgtttggggttt"
    "ttttggggRggggggggggggrrrrrrrrgggggggggggtgggtttttt"
    "ttttggggRgggggggggggggggrrgggggggggggggttggttttttt"
    "ttttggggRgggg11ggggtgggggggggggggggggggggggttttttt"
    "tttgggggRtttt22tttttttttgggggggtgggggggttttttttttt"
    "tttttggtRtt1tttttgttttttttgggttttggggttttttttttttt"
    "ttttttttRtt2tttttttttttttttttttttttttttttttttttttt"
)$
TileSetAll(MainField, 10, 41, ROOF_BIT | TILE_MOUNTAIN)$
TileSetAll(MainField, 10, 42, ROOF_BIT | TILE_MOUNTAIN)$
TileSetAll(MainField, 10, 43, ROOF_BIT | TILE_MOUNTAIN)$

TileAddTile(MainField, TILE_BASE_CHARACTER, C_BLACK, 0, makeCharacterTile())$
TileAddTile(MainField, TILE_PACKRAT, C_BLACK, 0, makePackratTile())$
TileAddTile(MainField, TILE_CARETAKER, C_BLACK, 0, makeCaretakerTile())$
TileAddTile(MainField, TILE_POSTMAN, C_BLACK, 0, makePostmanTile())$

use t_streets

define tp_tileWorld proc setTiles()void:
    list thing lt;
    int count, i;

    Packrat@p_pCharacterTile := TILE_PACKRAT;
    Caretaker@p_pCharacterTile := TILE_CARETAKER;
    lt := PostmenThing@p_Postmen;
    count := Count(lt);
    for i from 0 upto count - 1 do
	lt[i]@p_pCharacterTile := TILE_POSTMAN;
    od;
corp;

unuse t_streets

setTiles()$

TileAddTile(MainField, TILE_RIVER, -1, 0, makeRiverTile())$
TileAddTile(MainField, TILE_GRASS, -1, 0, makeGrassTile())$
TileAddTile(MainField, TILE_TREES, -1, 0, makeTreeTile())$
TileAddTile(MainField, TILE_MOUNTAIN, -1, 0, makeMountainTile())$
TileAddTile(MainField, TILE_PINE_TOP, C_RED, TILE_GRASS, makePineTopTile())$
TileAddTile(MainField, TILE_PINE_BOTTOM, -1, 0, makePineBottomTile())$
TileAddTile(MainField, TILE_OAK_TOP_LEFT, C_RED, TILE_GRASS, makeOakTLTile())$
TileAddTile(MainField, TILE_OAK_TOP_RIGHT, C_RED, TILE_GRASS, makeOakTRTile())$
TileAddTile(MainField, TILE_OAK_BOTTOM_LEFT, -1, 0, makeOakBLTile())$
TileAddTile(MainField, TILE_OAK_BOTTOM_RIGHT, -1, 0, makeOakBRTile())$

TileAddTile(MainField, TILE_ROAD, -1, 0, makeRoadTile())$
TileAddTile(MainField, TILE_BRIDGE, -1, 0, makeBridgeTile())$
TileAddTile(MainField, TILE_TOWN, -1, 0, makeTownTile())$
TileAddTile(MainField, TILE_TELEPORT, -1, 0, makeTeleportTile())$

TileAddTile(MainField, TILE_ROCK, C_BLACK, 0, makeRockTile())$
TileAddTile(MainField, TILE_LOG, C_BLACK, 0, makeLogTile())$
TileAddTile(MainField, TILE_BRANCHES, C_BLACK, 0, makeBranchesTile())$

unuse t_tiles

define tp_tileWorld proc addObject(int row, col, id; string name)void:
    thing theObject;

    theObject := CreateThing(nil);
    theObject@p_oObjectTile := id;
    theObject@p_oName := name;
    TileAddObject(MainField, theObject, row, col);
    SetThingStatus(theObject, ts_readonly);
corp;

addObject(6, 41, TILE_ROCK, "rock;large")$
addObject(16, 1, TILE_ROCK, "rock;large")$
addObject(2, 11, TILE_LOG, "log;large")$
addObject(48, 28, TILE_LOG, "log;large")$
addObject(42, 47, TILE_BRANCHES, "branches;small")$
addObject(40, 49, TILE_BRANCHES, "branches;small")$

define tp_tileWorld r_Common1 TileRoom("Fribble", "Town Common", 43, 22, 1, 4)$
TileAddPicture(r_Common1, D_NORTH, "common-north.jpg")$
TileAddPicture(r_Common1, D_SOUTH, "common-south.jpg")$

define tp_tileWorld r_Common2 TileRoom("Fribble", "Town Common", 41, 21, 2, 1)$
TileAddPicture(r_Common2, D_NORTH, "common-north.jpg")$
TileAddPicture(r_Common2, D_SOUTH, "common-south.jpg")$
TileSetRoom(MainField, 41, 21, r_Common2)$

define tp_tileWorld r_Fribble TileRoom("Town of", "Fribble", 41, 22, 2, 2)$
TileAddPicture(r_Fribble, D_WEST, "town-west.jpg")$
TileConnect(r_Common1, r_Fribble, D_NORTH)$
TileConnect(r_Common2, r_Fribble, D_EAST)$

define tp_tileWorld r_entrance TileRoom("Wilderness", "Entrance", 49, 8, 1, 1)$
TileAddPicture(r_entrance, D_HERE, "path.jpg")$
TileSetRoom(MainField, 49, 8, r_entrance)$

define tp_tileWorld proc teleport1(thing who; int row, col, dir)bool:

    TileDelCharacter();
    TileReEnter(nil, 40, 48);
    false
corp;

define tp_tileWorld proc teleport2(thing who; int row, col, dir)bool:

    TileDelCharacter();
    TileReEnter(nil, 2, 42);
    false
corp;

TileSetSpecialAction(MainField, 2, 42, teleport1)$
TileSetSpecialAction(MainField, 40, 48, teleport2)$

define tp_tileWorld proc backToRooms(thing who; int row, col, dir)bool:

    if dir = D_SOUTH then
	call(Tile@p_lmLeaveMode, void)(D_SOUTH);
	JumpToRoom(r_path3, D_NORTH);
	false
    else
	true
    fi
corp;

TileSetSpecialAction(MainField, 50, 8, backToRooms)$

replace enterTile()status:
    thing me;

    if GOn(nil) then
	me := Me();
	call(me@p_pCurrentMode@p_lmLeaveMode, void)(D_NORTH);
	call(Tile@p_lmResumeMode, void)();
	TileEnter(MainField, r_entrance, 49, 8);
	Print("Use \"shirt <colour>\" and \"pants <colour>\" to "
	    "decorate yourself.\n");
    else
	Print("North of here is a tile graphics world. If you do not have "
	      "a graphics display, it is very difficult to get back out "
	      "of that area.\n");
    fi;
    fail
corp;

define tp_misc proc TileWorldEnter()void:

    Me()@p_pCharacterTile := TILE_BASE_CHARACTER;
    TileEnter(MainField, r_Common1, 43, 25);
corp;


unuse tp_tileWorld
