/*
 * Amiga MUD
 *
 * Copyright (c) 1997 by Chris Gray
 */

/*
 * streets.m - define the outside streets in the starter dungeon.
 */

private tp_streets CreateTable()$
use tp_streets

define tp_streets STREETS_ID NextEffectId() $

define tp_streets ST_RD_WIDTH	35 $
define tp_streets ST_RD_HEIGHT	29 $
define tp_streets ST_SW_WIDTH	CURSOR_WIDTH $
define tp_streets ST_SW_HEIGHT	CURSOR_HEIGHT $
define tp_streets ST_BL_WIDTH	(DRAW_COLS - ST_RD_WIDTH - 2 * ST_SW_WIDTH)/2 $
define tp_streets ST_BL_HEIGHT	(DRAW_ROWS - ST_RD_HEIGHT - 2 *ST_SW_HEIGHT)/2$
define tp_streets ST_DG_HORIZ	(ST_BL_WIDTH - 3 * DOOR_WIDTH) / 4 $
define tp_streets ST_DG_VERT	(ST_BL_HEIGHT - 3 * DOOR_WIDTH) / 4 $
define tp_streets ST_PK_CX	DRAW_COLS - ST_SW_WIDTH -
				    (ST_BL_WIDTH - ST_SW_WIDTH) / 2 $
define tp_streets ST_PK_CY	DRAW_ROWS - ST_SW_HEIGHT -
				    (ST_BL_HEIGHT - ST_SW_HEIGHT) / 2 $

define tp_streets proc drawStreets()void:

    if not KnowsEffect(nil, STREETS_ID) then
	DefineEffect(nil, STREETS_ID);
	GSetImage(nil, "Town/streets");
	IfFound(nil);
	    ShowCurrentImage();
	Else(nil);
	    ClearTo(C_DARK_GREY);
	    
	    GSetPen(nil, C_LIGHT_GREY);
	    GAMovePixels(nil, 0, 0);
	    GRectanglePixels(nil, ST_BL_WIDTH + ST_SW_WIDTH,
				  ST_BL_HEIGHT + ST_SW_HEIGHT, true);
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH - ST_SW_WIDTH, 0);
	    GRectanglePixels(nil, ST_BL_WIDTH + ST_SW_WIDTH,
				  ST_BL_HEIGHT + ST_SW_HEIGHT, true);
	    GAMovePixels(nil, 0, DRAW_ROWS - ST_BL_HEIGHT - ST_SW_HEIGHT);
	    GRectanglePixels(nil, ST_BL_WIDTH + ST_SW_WIDTH,
				  ST_BL_HEIGHT + ST_SW_HEIGHT, true);
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH - ST_SW_HEIGHT,
			      DRAW_ROWS - ST_BL_HEIGHT - ST_SW_HEIGHT);
	    GRectanglePixels(nil, ST_BL_WIDTH + ST_SW_WIDTH,
				  ST_BL_HEIGHT + ST_SW_HEIGHT, true);

	    GSetPen(nil, C_DARK_BROWN);
	    GAMovePixels(nil, 0, 0);
	    GRectanglePixels(nil, ST_BL_WIDTH, ST_BL_HEIGHT, true);
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH, 0);
	    GRectanglePixels(nil, ST_BL_WIDTH, ST_BL_HEIGHT, true);
	    GAMovePixels(nil, 0, DRAW_ROWS - ST_BL_HEIGHT);
	    GRectanglePixels(nil, ST_BL_WIDTH, ST_BL_HEIGHT, true);

	    GSetPen(nil, C_WHITE);
	    GAMovePixels(nil, DRAW_COLS / 2, 0);
	    GADrawPixels(nil, DRAW_COLS / 2, ST_BL_HEIGHT);
	    GAMovePixels(nil, 0, DRAW_ROWS / 2);
	    GADrawPixels(nil, ST_BL_WIDTH, DRAW_ROWS / 2);
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH, DRAW_ROWS / 2);
	    GADrawPixels(nil, DRAW_COLS - 1, DRAW_ROWS / 2);
	    GAMovePixels(nil, DRAW_COLS / 2, DRAW_ROWS - ST_BL_HEIGHT);
	    GADrawPixels(nil, DRAW_COLS / 2, DRAW_ROWS - 1);

	    GSetPen(nil, C_BLACK);
	    /* West side of north */
	    GAMovePixels(nil, ST_BL_WIDTH - 1, ST_BL_HEIGHT / 2);
	    VerticalDoor();
	    /* East side of north */
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH,
			      ST_DG_VERT + DOOR_WIDTH / 2);
	    VerticalDoor();
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH,
			      ST_DG_VERT * 2 + DOOR_WIDTH * 3 / 2);
	    VerticalDoor();
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH,
			      ST_DG_VERT * 3 + DOOR_WIDTH * 5 / 2);
	    VerticalDoor();
	    /* North side of east */
	    GAMovePixels(nil, DRAW_COLS - ST_DG_HORIZ * 3 - DOOR_WIDTH * 5 / 2,
			      ST_BL_HEIGHT - 1);
	    HorizontalDoor();
	    GAMovePixels(nil, DRAW_COLS - ST_DG_HORIZ * 2 - DOOR_WIDTH * 3 / 2,
			      ST_BL_HEIGHT - 1);
	    HorizontalDoor();
	    GAMovePixels(nil, DRAW_COLS - ST_DG_HORIZ - DOOR_WIDTH / 2,
			      ST_BL_HEIGHT - 1);
	    HorizontalDoor();
	    /* South side of west */
	    GAMovePixels(nil, ST_DG_HORIZ + DOOR_WIDTH / 2,
			      DRAW_ROWS - ST_BL_HEIGHT + 1);
	    HorizontalDoor();
	    GAMovePixels(nil, ST_DG_HORIZ * 2 + DOOR_WIDTH * 3 / 2,
			      DRAW_ROWS - ST_BL_HEIGHT + 1);
	    HorizontalDoor();
	    GAMovePixels(nil, ST_DG_HORIZ * 3 + DOOR_WIDTH * 5 / 2,
			      DRAW_ROWS - ST_BL_HEIGHT + 1);
	    HorizontalDoor();
	    /* West side of south */
	    GAMovePixels(nil, ST_BL_WIDTH - 1,
			      DRAW_ROWS - ST_DG_VERT * 3 - DOOR_WIDTH * 5 / 2);
	    VerticalDoor();
	    GAMovePixels(nil, ST_BL_WIDTH - 1,
			      DRAW_ROWS - ST_DG_VERT * 2 - DOOR_WIDTH * 3 / 2);
	    VerticalDoor();
	    GAMovePixels(nil, ST_BL_WIDTH - 1,
			      DRAW_ROWS - ST_DG_VERT - DOOR_WIDTH / 2);
	    VerticalDoor();

	    /* North side of west */
	    GAMovePixels(nil, ST_BL_WIDTH / 2 - DOOR_WIDTH / 2, ST_BL_HEIGHT);
	    GADrawPixels(nil, ST_BL_WIDTH / 2 + DOOR_WIDTH / 2, ST_BL_HEIGHT);

	    GSetPen(nil, C_LIGHT_GREEN);
	    GAMovePixels(nil, DRAW_COLS - ST_BL_WIDTH,
			      DRAW_ROWS - ST_BL_HEIGHT);
	    GRectanglePixels(nil, ST_BL_WIDTH - ST_SW_WIDTH,
				  ST_BL_HEIGHT - ST_SW_HEIGHT, true);
	    GSetPen(nil, C_LIGHT_GREY);
	    GAMovePixels(nil, ST_PK_CX - ST_SW_WIDTH / 2,
			      DRAW_ROWS - ST_BL_HEIGHT);
	    GRectanglePixels(nil, ST_SW_WIDTH, ST_BL_HEIGHT, true);
	    GAMovePixels(nil, ST_PK_CX - ST_SW_WIDTH * 2,
			      ST_PK_CY - ST_SW_HEIGHT * 2);
	    GRectanglePixels(nil, ST_SW_WIDTH * 4, ST_SW_HEIGHT * 4, true);
	    GSetPen(nil, C_BLUE);
	    GAMovePixels(nil, ST_PK_CX - ST_SW_WIDTH, ST_PK_CY - ST_SW_HEIGHT);
	    GRectanglePixels(nil, ST_SW_WIDTH * 2, ST_SW_HEIGHT * 2, true);
	    GSetPen(nil, C_GOLD);
	    GAMovePixels(nil, ST_PK_CX, ST_PK_CY);
	    GCirclePixels(nil, ST_SW_WIDTH / 2, true);
	    GSetPen(nil, C_ORANGE);
	    GCirclePixels(nil, ST_SW_WIDTH / 4, true);

	    GSetPen(nil, C_FOREST_GREEN);
	    /* upper left */
	    GAMovePixels(nil, ST_PK_CX - 3 * ST_SW_WIDTH,
			      ST_PK_CY - 2 * ST_SW_HEIGHT - 2);
	    GCirclePixels(nil, ST_SW_WIDTH + 1, true);
	    /* lower left */
	    GAMovePixels(nil, ST_PK_CX - 4 * ST_SW_WIDTH + 6,
			      ST_PK_CY + 2 * ST_SW_HEIGHT + 4);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 + 3, true);
	    GAMovePixels(nil, ST_PK_CX - 3 * ST_SW_WIDTH + 10,
			      ST_PK_CY + 2 * ST_SW_HEIGHT + 1);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 + 1, true);
	    GAMovePixels(nil, ST_PK_CX - ST_SW_WIDTH + 3,
			      ST_PK_CY + 2 * ST_SW_HEIGHT + 4);
	    GCirclePixels(nil, ST_SW_WIDTH / 2, true);
	    /* upper right */
	    GAMovePixels(nil, ST_PK_CX + 2 * ST_SW_WIDTH - 9,
			      ST_PK_CY - 2 * ST_SW_HEIGHT - 4);
	    GCirclePixels(nil, ST_SW_WIDTH - 4, true);
	    GAMovePixels(nil, ST_PK_CX + 3 * ST_SW_WIDTH,
			      ST_PK_CY - 2 * ST_SW_HEIGHT - 1);
	    GCirclePixels(nil, ST_SW_WIDTH, true);
	    /* lower right */
	    GAMovePixels(nil, ST_PK_CX + ST_SW_WIDTH - 1,
			      ST_PK_CY + 3 * ST_SW_HEIGHT - 4);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 - 1, true);
	    GAMovePixels(nil, ST_PK_CX + ST_SW_WIDTH * 2 - 1,
			      ST_PK_CY + 3 * ST_SW_HEIGHT - 6);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 + 2, true);
	    GAMovePixels(nil, ST_PK_CX + ST_SW_WIDTH * 3 + 1,
			      ST_PK_CY + 2 * ST_SW_HEIGHT);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 + 2, true);
	    GAMovePixels(nil, ST_PK_CX + ST_SW_WIDTH * 4 - 6,
			      ST_PK_CY + 1);
	    GCirclePixels(nil, ST_SW_WIDTH / 2 + 3, true);
	Fi(nil);
	EndEffect();
    fi;
    CallEffect(nil, STREETS_ID);
corp;

define tp_streets ST_PS_WEST	ST_BL_WIDTH + CURSOR_WIDTH / 2 $
define tp_streets ST_PS_EAST	DRAW_COLS - ST_BL_WIDTH - CURSOR_WIDTH / 2 $
define tp_streets ST_PS_NORTH	ST_BL_HEIGHT + CURSOR_HEIGHT / 2 $
define tp_streets ST_PS_SOUTH	DRAW_ROWS - ST_BL_HEIGHT - CURSOR_HEIGHT / 2 $


define tp_streets STREETS_MAP_GROUP NextMapGroup()$

define tp_streets proc streetPos(thing room; int x, y)void:

    RoomGraphics(room, "Street", "", STREETS_MAP_GROUP, x, y, drawStreets);
corp;

define tp_streets proc makeStreet(thing parent; int x, y)thing:
    thing newStreet;

    newStreet := CreateThing(parent);
    newStreet@p_lContents := CreateThingList();
    SetThingStatus(newStreet, ts_readonly);
    streetPos(newStreet, x, y);
    newStreet
corp;

define tp_streets proc makeStreetP(thing parent; int x, y)thing:
    thing newStreet;

    newStreet := CreateThing(parent);
    newStreet@p_lContents := CreateThingList();
    SetThingStatus(newStreet, ts_public);
    streetPos(newStreet, x, y);
    newStreet
corp;

define tp_streets BIRDS_SING_ID NextSoundEffectId()$

define tp_streets proc birdsSingOnce(thing client)void:
    if SOn(client) then
	SPlaySound(client, "birds2", 1, BIRDS_SING_ID);
	IfFound(client);
	Else(client);
	    FailText(client, "Some birds sing.");
	Fi(client);
    else
	SPrint(client, "Some birds sing.\n");
    fi;
corp;

define tp_streets proc parkBirds()status:
    if Random(5) = 0 then
	ForEachAgent(Here(), birdsSingOnce);
	birdsSingOnce(Me());
    fi;
    continue
corp;

define tp_streets proc parkPos(thing room; int x, y)void:

    RoomGraphics(room, "Park", "", STREETS_MAP_GROUP, x, y, drawStreets);
corp;

define tp_streets proc makePark(string name, desc; int x, y)thing:
    thing newPark;

    newPark := CreateThing(r_park);
    newPark@p_lName := name;
    if desc ~= "" then
	newPark@p_rDesc := desc;
    fi;
    newPark@p_lContents := CreateThingList();
    SetThingStatus(newPark, ts_readonly);
    parkPos(newPark, x, y);
    AddAnyEnterChecker(newPark, parkBirds, false);
    newPark
corp;

define tp_streets proc makeParkP(string name, desc; int x, y)thing:
    thing newPark;

    newPark := CreateThing(r_park);
    newPark@p_lName := name;
    if desc ~= "" then
	newPark@p_rDesc := desc;
    fi;
    newPark@p_lContents := CreateThingList();
    SetThingStatus(newPark, ts_public);
    parkPos(newPark, x, y);
    AddAnyEnterChecker(newPark, parkBirds, false);
    newPark
corp;

define tp_streets proc makeDingy(string name, desc; int x, y)thing:
    thing newDingy;

    newDingy := CreateThing(r_park);
    newDingy@p_lName := name;
    if desc ~= "" then
	newDingy@p_rDesc := desc;
    fi;
    newDingy@p_lContents := CreateThingList();
    SetThingStatus(newDingy, ts_public);
    RoomGraphics(newDingy, "Dingy", "Sidewalk", STREETS_MAP_GROUP, x, y,
		 drawStreets);
    newDingy
corp;

define tp_streets r_crossNE CreateThing(r_sidewalk)$
SetupRoom(r_crossNE, "on the north-east corner of the main intersection",
    "Handy sidewalks head north and east, and you can cross the streets "
    "to the south and west.")$
streetPos(r_crossNE, ST_PS_EAST, ST_PS_NORTH)$

define tp_streets r_crossNW CreateThing(r_sidewalk)$
SetupRoom(r_crossNW, "on the north-west corner of the main intersection",
    "Handy sidewalks head north and west, and you can cross the streets "
    "to the south and east.")$
streetPos(r_crossNW, ST_PS_WEST, ST_PS_NORTH)$

define tp_streets r_crossSE CreateThing(r_sidewalk)$
SetupRoom(r_crossSE, "on the south-east corner of the main intersection",
    "Handy sidewalks head south and east alongside the park, and you can "
    "cross the streets to the north and west.")$
streetPos(r_crossSE, ST_PS_EAST, ST_PS_SOUTH)$

/* put r_crossSW in tp_misc, since is needed in machines.m */
define tp_misc r_crossSW CreateThing(r_sidewalk)$
SetupRoom(r_crossSW, "on the south-west corner of the main intersection",
    "Handy sidewalks head south and west, and you can cross the streets "
    "to the north and east.")$
streetPos(r_crossSW, ST_PS_WEST, ST_PS_SOUTH)$

Connect(r_crossNE, r_crossNW, D_WEST)$
Connect(r_crossNE, r_crossSE, D_SOUTH)$
Connect(r_crossSW, r_crossSE, D_EAST)$
Connect(r_crossSW, r_crossNW, D_NORTH)$

define tp_streets r_nw CreateThing(r_sidewalk)$
SetThingStatus(r_nw, ts_readonly)$
r_nw@p_lName := "on the west sidewalk, north of the main intersection"$
define tp_streets r_nw1 makeStreet(r_nw, ST_PS_WEST,
    ST_DG_VERT * 3 + DOOR_WIDTH * 5 / 2)$
Connect(r_crossNW, r_nw1, D_NORTH)$
define tp_streets r_nw2 makeStreet(r_nw, ST_PS_WEST,
    ST_DG_VERT * 2 + DOOR_WIDTH * 3 / 2)$
Connect(r_nw1, r_nw2, D_NORTH)$
define tp_streets r_nw3 makeStreet(r_nw, ST_PS_WEST,
    ST_DG_VERT + DOOR_WIDTH / 2)$
r_nw3@p_rDesc := "You can cross the street to the east."$
Connect(r_nw2, r_nw3, D_NORTH)$
define tp_streets r_ne CreateThing(r_sidewalk)$
SetThingStatus(r_ne, ts_readonly)$
r_ne@p_lName := "on the east sidewalk, north of the main intersection"$
define t_streets r_ne1 makeStreetP(r_ne, ST_PS_EAST,
    ST_DG_VERT * 3 + DOOR_WIDTH * 5 / 2)$
Connect(r_crossNE, r_ne1, D_NORTH)$
define t_streets r_ne2 makeStreetP(r_ne, ST_PS_EAST,
    ST_DG_VERT * 2 + DOOR_WIDTH * 3 / 2)$
Connect(r_ne1, r_ne2, D_NORTH)$
define t_streets r_ne3 makeStreetP(r_ne, ST_PS_EAST,
    ST_DG_VERT + DOOR_WIDTH / 2)$
r_ne3@p_rDesc := "You can cross the street to the west."$
Connect(r_ne2, r_ne3, D_NORTH)$
Connect(r_nw3, r_ne3, D_EAST)$

define tp_streets r_en CreateThing(r_sidewalk)$
SetThingStatus(r_en, ts_readonly)$
r_en@p_lName := "on the north sidewalk, east of the main intersection"$
define t_streets r_en1 makeStreetP(r_en,
    DRAW_COLS - ST_DG_HORIZ * 3 - DOOR_WIDTH * 5 / 2, ST_PS_NORTH)$
Connect(r_crossNE, r_en1, D_EAST)$
define t_streets r_en2 makeStreetP(r_en,
    DRAW_COLS - ST_DG_HORIZ * 2 - DOOR_WIDTH * 3 / 2, ST_PS_NORTH)$
Connect(r_en1, r_en2, D_EAST)$
define t_streets r_en3 makeStreetP(r_en,
    DRAW_COLS - ST_DG_HORIZ - DOOR_WIDTH / 2, ST_PS_NORTH)$
Connect(r_en2, r_en3, D_EAST)$
r_en3@p_rDesc := "You can cross the street to the south."$
define tp_streets r_es CreateThing(r_sidewalk)$
SetThingStatus(r_es, ts_readonly)$
r_es@p_lName := "on the south sidewalk, east of the main intersection"$
r_es@p_rDesc := "The rail fence around the park is to your south."$
Scenery(r_es, "fence;rail.railing,rail")$
define tp_streets r_es1 makeStreet(r_es, (ST_PS_EAST + ST_PK_CX) / 2,
    ST_PS_SOUTH)$
Connect(r_crossSE, r_es1, D_EAST)$
/* put r_es2 in tp_misc, since it is needed in machine.m */
define tp_misc r_es2 makeStreet(r_es, ST_PK_CX, ST_PS_SOUTH)$
r_es2@p_rDesc := "The north park entrance is to your south."$
Connect(r_es1, r_es2, D_EAST)$
define tp_streets r_es3 makeStreet(r_es,
    (DRAW_COLS - CURSOR_WIDTH / 2 + ST_PK_CX) / 2, ST_PS_SOUTH)$
Connect(r_es2, r_es3, D_EAST)$
define t_streets r_es4 makeStreetP(r_es, DRAW_COLS - CURSOR_WIDTH / 2,
    ST_PS_SOUTH)$
r_es4@p_rDesc :=
    "You can cross the street to the north or go south alongside the park."$
Connect(r_es3, r_es4, D_EAST)$
Connect(r_en3, r_es4, D_SOUTH)$

define tp_streets r_wn CreateThing(r_sidewalk)$
SetThingStatus(r_wn, ts_readonly)$
r_wn@p_lName := "on the north sidewalk, west of the main intersection"$
define tp_streets r_wn1 makeStreet(r_wn, ST_DG_HORIZ * 3 + DOOR_WIDTH * 5 / 2,
    ST_PS_NORTH)$
Connect(r_crossNW, r_wn1, D_WEST)$
define t_streets r_wn2 makeStreet(r_wn, ST_DG_HORIZ * 2 + DOOR_WIDTH * 3 / 2,
    ST_PS_NORTH)$
Connect(r_wn1, r_wn2, D_WEST)$
define t_streets r_wn3 makeStreet(r_wn, ST_DG_HORIZ + DOOR_WIDTH / 2,
    ST_PS_NORTH)$
r_wn3@p_rDesc := "You can cross the street to the south."$
Connect(r_wn2, r_wn3, D_WEST)$
define tp_streets r_ws CreateThing(r_sidewalk)$
SetThingStatus(r_ws, ts_readonly)$
r_ws@p_lName := "on the south sidewalk, west of the main intersection"$
define t_streets r_ws1 makeStreetP(r_ws, ST_DG_HORIZ * 3 + DOOR_WIDTH * 5 / 2,
    ST_PS_SOUTH)$
Connect(r_crossSW, r_ws1, D_WEST)$
define t_streets r_ws2 makeStreetP(r_ws, ST_DG_HORIZ * 2 + DOOR_WIDTH * 3 / 2,
    ST_PS_SOUTH)$
Connect(r_ws1, r_ws2, D_WEST)$
define t_streets r_ws3 makeStreetP(r_ws, ST_DG_HORIZ + DOOR_WIDTH / 2,
    ST_PS_SOUTH)$
r_ws3@p_rDesc := "You can cross the street to the north."$
Connect(r_ws2, r_ws3, D_WEST)$
Connect(r_wn3, r_ws3, D_SOUTH)$

define tp_streets r_sw CreateThing(r_sidewalk)$
SetThingStatus(r_sw, ts_readonly)$
r_sw@p_lName := "on the west sidewalk, south of the main intersection"$
define tp_streets r_sw1 makeStreetP(r_sw, ST_PS_WEST,
    DRAW_ROWS - ST_DG_VERT * 3 - DOOR_WIDTH * 5 / 2)$
Connect(r_crossSW, r_sw1, D_SOUTH)$
/* r_sw2 is in tp_misc, since it is needed in bguild.m */
define tp_misc r_sw2 makeStreet(r_sw, ST_PS_WEST,
    DRAW_ROWS - ST_DG_VERT * 2 - DOOR_WIDTH * 3 / 2)$
Connect(r_sw1, r_sw2, D_SOUTH)$
define t_streets r_sw3 makeStreetP(r_sw, ST_PS_WEST,
    DRAW_ROWS - ST_DG_VERT - DOOR_WIDTH / 2)$
r_sw3@p_rDesc := "You can cross the street to the east."$
Connect(r_sw2, r_sw3, D_SOUTH)$
define tp_streets r_se CreateThing(r_sidewalk)$
SetThingStatus(r_se, ts_readonly)$
r_se@p_lName := "on the east sidewalk, south of the main intersection"$
r_se@p_rDesc := "The rail fence around the park is to your east."$
Scenery(r_se, "fence;rail.railing,rail")$
define tp_streets r_se1 makeStreet(r_se, ST_PS_EAST,
    (ST_PS_SOUTH + DRAW_ROWS - CURSOR_HEIGHT / 2) / 2)$
Connect(r_crossSE, r_se1, D_SOUTH)$
define t_streets r_se2 makeStreetP(r_se, ST_PS_EAST,
    DRAW_ROWS - CURSOR_HEIGHT / 2)$
r_se2@p_rDesc :=
    "There is a nice park to your east, filled with grass and trees. You "
    "can also see a couple of small buildings, and perhaps some water. "
    "You can cross the street to the west or go east alongside the park."$
Connect(r_se1, r_se2, D_SOUTH)$
Connect(r_sw3, r_se2, D_EAST)$

/* The park: */

define tp_streets FOUNTAIN_SOUND_ID NextSoundEffectId()$
define tp_streets proc doStartFountainSound()void:
    if SOn(nil) then
	SVolume(nil, 4000);
	SPlaySound(nil, "stream", 0, FOUNTAIN_SOUND_ID);
	SVolume(nil, 10000);
    fi;
corp;
define tp_streets proc startFountainSound()status:
    if Character(Me()@p_pName) ~= nil then
	if FindElement(Me()@p_pEnterActions, doStartFountainSound) = -1 then
	    /* Check is just paranoia - poofing may mess things up. */
	    AddTail(Me()@p_pEnterActions, doStartFountainSound);
	fi;
	doStartFountainSound();
    fi;
    continue
corp;
define tp_streets proc stopFountainSound()status:
    if Character(Me()@p_pName) ~= nil then
	if SOn(nil) then
	    AbortEffect(nil, EFFECT_SOUND, FOUNTAIN_SOUND_ID);
	fi;
	DelElement(Me()@p_pEnterActions, doStartFountainSound);
    fi;
    continue
corp;
define tp_streets r_parkNorth makePark("at the north entrance to the park",
    "The street is to the north and park walks head east and west. Directly "
    "south of you is the park's central fountain.", ST_PK_CX,
    ST_PK_CY - ST_SW_HEIGHT * 3 / 2)$
Connect(r_es2, r_parkNorth, D_SOUTH)$
AddSouthChecker(r_es2, startFountainSound, false)$
AddNorthChecker(r_parkNorth, stopFountainSound, false)$
define tp_streets o_fountainWater CreateThing(nil)$
FakeObject(o_fountainWater, r_parkNorth,
    "water;central,fountain.fountain;water,in,from,the.mermaid;ugly,bronze",
    "The fountain is a square hole in the sidewalk, filled with water. An "
    "ugly bronze mermaid dribbles water into it. The water has a slightly "
    "greenish tinge, and smells of too much chlorine.")$
o_fountainWater@p_oEatString :=
    "Drink the water from that fountain? Ick! No way!"$
o_fountainWater@p_oTouchString :=
    "You can't reach the bronze mermaid, "
    "and the water is merely tepid and wet."$
o_fountainWater@p_oSmellString := "You can smell the acrid tang of chlorine."$
o_fountainWater@p_oListenString := "You can hear the fountain splashing."$
define tp_streets r_parkNorthEast makePark(
    "at the northeast corner of the park walk", "",
    ST_PK_CX + ST_SW_WIDTH * 3 / 2,
    ST_PK_CY - ST_SW_HEIGHT * 3 / 2)$
Connect(r_parkNorth, r_parkNorthEast, D_EAST)$
AddTail(r_parkNorthEast@p_lContents, o_fountainWater)$
define tp_streets r_parkNorthWest makePark(
    "at the northwest corner of the park walk", "",
    ST_PK_CX - ST_SW_WIDTH * 3 / 2,
    ST_PK_CY - ST_SW_HEIGHT * 3 / 2)$
Connect(r_parkNorth, r_parkNorthWest, D_WEST)$
AddTail(r_parkNorthWest@p_lContents, o_fountainWater)$
define tp_streets r_parkEast makeParkP("east of the fountain", "",
    ST_PK_CX + ST_SW_WIDTH * 3 / 2, ST_PK_CY)$
Connect(r_parkNorthEast, r_parkEast, D_SOUTH)$
AddTail(r_parkEast@p_lContents, o_fountainWater)$
define tp_streets r_parkWest makeParkP("west of the fountain", "",
    ST_PK_CX - ST_SW_WIDTH * 3 / 2, ST_PK_CY)$
Connect(r_parkNorthWest, r_parkWest, D_SOUTH)$
AddTail(r_parkWest@p_lContents, o_fountainWater)$
define tp_streets r_parkSouthEast makePark(
    "at the southeast corner of the park walk", "",
    ST_PK_CX + ST_SW_WIDTH * 3 / 2,
    ST_PK_CY + ST_SW_HEIGHT * 3 / 2)$
Connect(r_parkEast, r_parkSouthEast, D_SOUTH)$
AddTail(r_parkSouthEast@p_lContents, o_fountainWater)$
define tp_streets r_parkSouthWest makePark(
    "at the southwest corner of the park walk", "",
    ST_PK_CX - ST_SW_WIDTH * 3 / 2,
    ST_PK_CY + ST_SW_HEIGHT * 3 / 2)$
Connect(r_parkWest, r_parkSouthWest, D_SOUTH)$
AddTail(r_parkSouthWest@p_lContents, o_fountainWater)$
define tp_streets r_parkSouth makePark("at the south entrance to the park",
    "A dingy sidewalk is to the south and park walks head east and west. "
    "Directly north of you is the park's central fountain.",
    ST_PK_CX, ST_PK_CY + ST_SW_HEIGHT * 3 / 2)$
Connect(r_parkSouthEast, r_parkSouth, D_WEST)$
Connect(r_parkSouthWest, r_parkSouth, D_EAST)$
AddTail(r_parkSouth@p_lContents, o_fountainWater)$
AddSouthChecker(r_parkSouth, stopFountainSound, false)$
define t_streets r_dingySouth makeDingy(
    "on a dingy east-west sidewalk",
    "The south park entrance is to your north.", ST_PK_CX,
    DRAW_ROWS - ST_SW_HEIGHT / 2)$
Connect(r_se2, r_dingySouth, D_EAST)$
Connect(r_parkSouth, r_dingySouth, D_SOUTH)$
AddNorthChecker(r_dingySouth, startFountainSound, false)$
define t_streets r_dingyCorner makeDingy(
    "on a corner of dingy sidewalks",
    "You can go north or west, both alongside the fenced-off park.",
    DRAW_COLS - ST_SW_WIDTH / 2, DRAW_ROWS - ST_SW_HEIGHT / 2)$
Connect(r_dingySouth, r_dingyCorner, D_EAST)$
Scenery(r_dingySouth, "park,fence,railing,rail;rail,fenced,off,fenced-off")$
define t_streets r_dingyEast makeDingy(
    "on a dingy north-south sidewalk east of the park", "",
    DRAW_COLS - ST_SW_WIDTH / 2,
    (ST_PS_SOUTH + DRAW_ROWS + ST_SW_HEIGHT / 2) / 2)$
Connect(r_dingyCorner, r_dingyEast, D_NORTH)$
Connect(r_es4, r_dingyEast, D_SOUTH)$

/* connect the street to the minimall */

ExtendDesc(r_nw2,
    "A passageway heads to the west. The walls and floor of the passageway "
    "are of brown tile, with a simple pattern of white tiles thrown in. The "
    "ceiling of the passageway is painted concrete, and fluorescent "
    "striplights (half of which don't work at all) cast intermittant light on "
    "the rubbish-strewn floor.")$
r_nw2@p_rWestDesc :=
    "The passageway is fairly large, and is poorly lit. It is obviously well "
    "used however. It is fairly long, but you can see a large open area at "
    "the far end."$
r_nw2@p_rWestMessage := "You head into the gloom of the passageway."$
r_nw2@p_rWestOMessage := "heads into the passageway."$
r_nw2@p_rWestEMessage := "comes out of the passageway."$
r_nw2@p_rEnterDesc :=
    "The passageway is fairly large, and is poorly lit. It is obviously well "
    "used however. It is fairly long, but you can see a large open area at "
    "the far end."$
r_nw2@p_rEnterMessage := "You head into the gloom of the passageway."$
r_nw2@p_rEnterOMessage := "heads into the passageway."$
Connect(r_nw2, r_mallEntrance, D_WEST)$
Connect(r_nw2, r_mallEntrance, D_ENTER)$
Scenery(r_nw2,
    "passageway,passage,floor,wall,ceiling;rubbish,strewn,rubbish-strewn."
    "tile;brown,white,patterned."
    "pattern;simple."
    "concrete,painted."
    "light,striplight;strip,fluorescent."
    "rubbish")$

/* Connect Questor's office to r_ws2 */

SetupQuestorOffice(r_ws2, D_SOUTH)$

/* Build a ring road around the town. */
/* I deliberately did not inherit from anything other than 'r_road' here,
   to make it easier for others to modify the roads. */

define tp_streets TOWN_ROAD_NORTH_ID NextEffectId()$
define tp_streets proc drawRoadNorth()void:

    if not KnowsEffect(nil, TOWN_ROAD_NORTH_ID) then
	DefineEffect(nil, TOWN_ROAD_NORTH_ID);
	GSetImage(nil, "Town/roadNorth");
	IfFound(nil);
	    ShowCurrentImage();
	Else(nil);
	    GSetPen(nil, C_DARK_GREEN);
	    GAMovePixels(nil, 0, 0);
	    GRectanglePixels(nil, DRAW_COLS, DRAW_ROWS, true);
	    GSetPen(nil, C_TAN);
	    AutoSimpleParts(B_SOUTH | B_EAST | B_WEST, ROAD_SCALE, true);
	    AutoSimpleParts(B_NORTH, PATH_SCALE, false);
	Fi(nil);
	EndEffect();
    fi;
    CallEffect(nil, TOWN_ROAD_NORTH_ID);
corp;
define tp_streets r_roadNorth CreateThing(r_road)$
SetupRoomP(r_roadNorth, "at a junction",
    "The town is to the south. A pathway leads to the north.")$
Connect(r_ne3, r_roadNorth, D_NORTH)$
UniConnect(r_nw3, r_roadNorth, D_NORTH)$
Scenery(r_roadNorth, "path.pathway")$
AutoRoomGraphics(r_roadNorth, drawRoadNorth)$

define t_streets r_roadNorthEast CreateThing(r_road)$
SetupRoomP(r_roadNorthEast, "at a corner in the road", "")$
Connect(r_roadNorth, r_roadNorthEast, D_EAST)$
AutoRoomGraphics(r_roadNorthEast, AutoRoads)$

define t_streets r_roadEast CreateThing(r_road)$
SetupRoomP(r_roadEast, "at a junction", "The town is to the west.")$
Connect(r_roadNorthEast, r_roadEast, D_SOUTH)$
Connect(r_es4, r_roadEast, D_EAST)$
UniConnect(r_en3, r_roadEast, D_EAST)$
AutoRoomGraphics(r_roadEast, AutoRoads)$

define t_streets r_roadSouthEast CreateThing(r_road)$
SetupRoomP(r_roadSouthEast, "at a corner in the road", "")$
Connect(r_roadEast, r_roadSouthEast, D_SOUTH)$
AutoRoomGraphics(r_roadSouthEast, AutoRoads)$

define t_streets r_roadSouth CreateThing(r_road)$
SetupRoomP(r_roadSouth, "at a junction", "The town is to the north.")$
Connect(r_roadSouthEast, r_roadSouth, D_WEST)$
Connect(r_se2, r_roadSouth, D_SOUTH)$
UniConnect(r_sw3, r_roadSouth, D_SOUTH)$
AutoRoomGraphics(r_roadSouth, AutoRoads)$

define t_streets r_roadSouthWest CreateThing(r_road)$
SetupRoomP(r_roadSouthWest, "at a corner in the road", "")$
Connect(r_roadSouth, r_roadSouthWest, D_WEST)$
AutoRoomGraphics(r_roadSouthWest, AutoRoads)$

define t_streets r_roadWest CreateThing(r_road)$
SetupRoomP(r_roadWest, "at a junction", "The town is to the east.")$
Connect(r_roadSouthWest, r_roadWest, D_NORTH)$
Connect(r_ws3, r_roadWest, D_WEST)$
UniConnect(r_wn3, r_roadWest, D_WEST)$
AutoRoomGraphics(r_roadWest, AutoRoads)$

define t_streets r_roadNorthWest CreateThing(r_road)$
SetupRoomP(r_roadNorthWest, "at a corner in the road", "")$
Connect(r_roadWest, r_roadNorthWest, D_NORTH)$
Connect(r_roadNorth, r_roadNorthWest, D_WEST)$
AutoRoomGraphics(r_roadNorthWest, AutoRoads)$

/* a bit of the great outdoors */

define t_streets r_path1 CreateThing(r_path)$
SetupRoomP(r_path1, "on a north-south pathway", "The town is to the south.")$
Connect(r_roadNorth, r_path1, D_NORTH)$
Scenery(r_path1, "town")$
AutoRoomGraphics(r_path1, AutoPaths)$

define t_streets r_path2 CreateThing(r_path)$
SetupRoomP(r_path2, "on a north-south pathway",
    "A small trail heads to the east.")$
SetThingStatus(r_path2, ts_public)$
Connect(r_path1, r_path2, D_NORTH)$
AutoRoomGraphics(r_path2, AutoPaths)$

/*
define t_streets r_path3 CreateThing(r_path)$
SetupRoomP(r_path3, "at a dead-end",
    "A large billboard reads: Castle lots for sale - apply with SysAdmin.")$
Connect(r_path2, r_path3, D_NORTH)$
AutoRoomGraphics(r_path3, AutoPaths)$
Sign(r_path3, "billboard,bill-board;large.board,large,bill", "",
    "Castle lots for sale - apply with SysAdmin")$
*/
define tp_misc r_path3 CreateThing(r_path)$
SetupRoomP(r_path3, "on a north-south pathway",
    "A large billboard reads: Wilderness to the North.")$
Connect(r_path2, r_path3, D_NORTH)$
AutoRoomGraphics(r_path3, AutoPaths)$
Sign(r_path3, "billboard,bill-board;large.board,large,bill", "",
    "Wilderness to the North")$

define t_streets r_pathFake CreateThing(r_path)$
SetupRoomP(r_pathFake, "", "")$
Connect(r_path3, r_pathFake, D_NORTH)$
define tp_misc proc enterTile()status:
    fail
corp;
AddNorthChecker(r_path3, enterTile, true)$

/* and now a connecting trail */

define t_streets r_ewTrail1 CreateThing(r_path)$
SetupRoomP(r_ewTrail1, "on an east-west trail", "")$
Connect(r_path2, r_ewTrail1, D_EAST)$
AutoRoomGraphics(r_ewTrail1, AutoPaths)$

define t_streets r_ewTrail2 CreateThing(r_path)$
SetupRoomP(r_ewTrail2, "on an east-west trail",
    "The trail continues to the east and the west. A line of trees starts "
    "just north of here and continues to the east. You can see the town to "
    "the south, but you can't get there from here.")$
Connect(r_ewTrail1, r_ewTrail2, D_EAST)$
Scenery(r_ewTrail2, "tree,line;line,of.town")$
r_ewTrail2@p_rNorthDesc :=
    "You can see trees and bushes to the north. You might be able to push "
    "your way through them."$
r_ewTrail2@p_rSouthDesc := "You can see the town in the distance."$
AutoRoomGraphics(r_ewTrail2, AutoPaths)$

define t_streets r_ewTrail3 CreateThing(r_outdoors)$
SetupRoomP(r_ewTrail3, "on an east-west trail",
    "The line of trees continues to the north, and you can see an open field "
    "to the east.")$
Scenery(r_ewTrail3, "trail.field.tree,line;line,of")$
Connect(r_ewTrail2, r_ewTrail3, D_EAST)$
r_ewTrail3@p_rNorthDesc := "You can see trees and bushes to the north."$
r_ewTrail3@p_rEastDesc :=
    "You can see an open field to the east. There is a large tree in it."$
AutoRoomGraphics(r_ewTrail3, AutoPaths)$

/* here for the next little while is the field with the pear tree */

define t_streets r_pearField CreateThing(r_field)$
SetupRoomP(r_pearField, "in a field",
    "There is a large pear tree here, full of pears. "
    "A small trail heads west.")$
Connect(r_ewTrail3, r_pearField, D_EAST)$
Scenery(r_pearField, "trail,gully")$
r_pearField@p_rNorthDesc :=
    "You can see the edge of a bushy gully to the north."$
define tp_streets proc drawPearField()void:
    AutoPaths();
    GSetPen(nil, C_DARK_GREEN);
    GAMove(nil, 0.75, 0.5);
    GCircle(nil, 0.18, true);
corp;
AutoRoomGraphics(r_pearField, drawPearField)$
r_pearField@p_oSmellString := "The air here smells quite fresh and clean!"$
r_pearField@p_Image := "Town/pearField"$

define tp_streets o_pearTree CreateThing(nil)$
SetupObject(o_pearTree, r_pearField, "tree;large,pear.branch,branches;loaded",
    "The tree is quite large, with many long branches loaded with pears. "
    "It stands by itself in the center of this small field. Many of the "
    "branches come within easy reach.")$
o_pearTree@p_oInvisible := true$
o_pearTree@p_oSmellString := "The pear tree smells somewhat woody."$
o_pearTree@p_Image := "Town/pearTree"$

define tp_streets o_pearOnTree CreateThing(nil)$
SetupObject(o_pearOnTree, r_pearField, "pear;plump,juicy",
    "The pears on the tree look quite delicious.")$
o_pearOnTree@p_oInvisible := true$
o_pearOnTree@p_oEatString := "You should pick a pear from the tree first."$
o_pearOnTree@p_oSmellString := o_pearOnTree@p_oEatString$
o_pearOnTree@p_oTouchString := o_pearOnTree@p_oEatString$

/* Special procs for the pears. Note the lack of 'utility', since we
   make the pears belong to whoever sources this file */

define tp_streets proc pearDrop(thing pear)status:
    thing carryer;

    carryer := pear@p_oCarryer;
    ClearThing(pear);
    SPrint(carryer, "The pear drops and is pulped!\n");
    MaybeShowAlt(carryer,
	Capitalize(CharacterNameG(carryer)) + " drops a pear which sploops.\n",
	"You hear a smack! sound.\n");
    DelElement(carryer@p_pCarrying, pear);
    /* we have just destroyed the pear and already dropped it, we do NOT
       want to continue with normal drop processing */
    succeed
corp;

define tp_streets proc pearEat()status:
    thing th, me;

    th := It();
    me := Me();
    if th@p_oCreator = me then
	Print("You eat the pear. It was really good.\n");
	if not me@p_pHidden and
	    call(me@p_pCurrentMode@p_lmCanSeeHere, bool)(me)
	then
	    ShowHere(Capitalize(CharacterNameG(me)) + " eats a pear.\n");
	else
	    ShowHere("You hear some slurping noises.\n");
	fi;
	ClearThing(th);
	DelElement(me@p_pCarrying, th);
    else
	Print("That's not your pear!\n");
    fi;
    /* do NOT continue with normal 'eat' processing */
    succeed
corp;

define tp_streets proc pearGive(thing target)status:
    thing me, pear;

    me := Me();
    pear := It();
    if pear@p_oCreator = me then
	Print("You fumble when trying to give away the pear, and drop it!\n");
	if not me@p_pHidden and
	    call(me@p_pCurrentMode@p_lmCanSeeHere, bool)(me)
	then
	    ShowHere(Capitalize(CharacterNameG(me)) +
		" drops a pear which sploops.\n");
	else
	    ShowHere("You hear a smack! sound.\n");
	fi;
	ClearThing(pear);
	DelElement(me@p_pCarrying, pear);
    else
	Print("That's not your pear!\n");
    fi;
    /* the give never works */
    fail
corp;

define tp_streets proc pearPutIn(thing pear, container)status:
    string containerName;

    containerName := FormatName(container@p_oName);
    Print("You drop the pear into the " + containerName +
	". Unfortunately, the pear doesn't survive the dropping - it is "
	"squished. You shake out the pieces and clean the mess out of the " +
	containerName + ".\n");
    ClearThing(pear);
    DelElement(Me()@p_pCarrying, pear);
    succeed
corp;

define tp_streets o_pearInHand CreateThing(nil)$
o_pearInHand@p_oName := "pear;plump,juicy"$
o_pearInHand@p_oDesc := "The pear looks exceedingly delicious!"$
o_pearInHand@p_oEatChecker := pearEat$
o_pearInHand@p_oDropChecker := pearDrop$
o_pearInHand@p_oPutMeInChecker := pearPutIn$
o_pearInHand@p_oSmellString := "The pear smells like a pear."$
o_pearInHand@p_oTouchString := "Surprise! The pear feels like a pear."$
o_pearInHand@p_Image := "Town/pear"$
SetThingStatus(o_pearInHand, ts_public)$

define tp_streets proc pearGet(thing th)status:
    thing me;

    me := Me();
    if FindChildOnList(me@p_pCarrying, o_pearInHand) then
	Print("Don't be greedy! You already have a pear.\n");
    else
	/* will be owned by the real player */
	th := CreateThing(o_pearInHand);
	th@p_oCreator := me;
	SetThingStatus(th, ts_public);
	if CarryItem(th) then
	    /* This is put directly on the individual pears, so that it can
	       be removed in 'questPearGive'. */
	    th@p_oGiveChecker := pearGive;
	    Print("You pick a pear from the tree.\n");
	    /* assume it is not dark */
	    if not me@p_pHidden then
		OPrint(Capitalize(CharacterNameG(me)) +
		       " picks a pear from the tree.\n");
	    fi;
	else
	    ClearThing(th);
	fi;
    fi;
    /* do not want to continue with normal get processing */
    succeed
corp;

o_pearOnTree@p_oGetChecker := pearGet$

define tp_streets proc questPearDesc()string:

    "Bring me two pears."
corp;

define tp_streets proc questPearGive()status:
    thing pear;
    bool hadOne;

    pear := It();
    if Parent(pear) = o_pearInHand then
	/* make it not sploop */
	hadOne :=
	    FindChildOnList(FindAgent("Questor")@p_pCarrying, o_pearInHand);
	pear -- p_oGiveChecker;
	if hadOne then
	    GiveToQuestor("plump juicy pear");
	    succeed
	else
	    continue
	fi
    elif pear@p_oName = "pear;plump,juicy" then
	GiveToQuestor("plump juicy pear");
	SPrint(TrueMe(), "Questor is not impressed.\n");
	fail
    else
	continue
    fi
corp;

define tp_streets proc questPearHint()string:

    "Perhaps you need help from a friendly flower."
corp;

QuestGive("Pear", questPearDesc, questPearGive, questPearHint)$

define tp_streets proc pearTreeGet(thing th)status:
    Print("The tree is far too large for you to carry, and in any event, "
	    "it is securely rooted to the ground.\n");
    if Me()@p_pHidden then
	OPrint("The tree shakes slightly.\n");
    else
	OPrint(Capitalize(CharacterNameG(Me())) +
	       " seems to be embracing the tree.\n");
    fi;
    succeed
corp;

o_pearTree@p_oGetChecker := pearTreeGet$

unuse tp_streets
